#pragma once

#include <imedit/image.h>

namespace imedit
{

    static Pixel color_from_proxy(const std::vector<Pixel> &colors, double proxy, bool flip_half = false)
    {
        float location = proxy * float(colors.size() - 1);
        float diff = location - floor(location);
        // float diff = ceil(location) - location;
        int index_one = floor(location);
        int index_two = index_one + 1;
        if (index_two > colors.size() - 1)
            index_two = index_one;

        // if (flip_half && index_one < colors.size() / 2)
        // {
        //     int tmp = index_two;
        //     index_two = index_one;
        //     index_one = tmp;
        // }

        Pixel color_one = colors[index_one];
        Pixel color_two = colors[index_two];

        // if (flip_half && index_one < colors.size() / 2)
        // {
        //     return Pixel(color_two.r * (1.f - diff) + color_one.r * diff,
        //                  color_two.g * (1.f - diff) + color_one.g * diff,
        //                  color_two.b * (1.f - diff) + color_one.b * diff);
        // }

        return Pixel(color_one.r * (1.f - diff) + color_two.r * diff,
                     color_one.g * (1.f - diff) + color_two.g * diff,
                     color_one.b * (1.f - diff) + color_two.b * diff);
    }

    static Pixel color_from_proxy_basic(const std::vector<Pixel> &colors, double proxy, bool flip_half = false)
    {
        double location = proxy * double(colors.size() - 1);
        double diff = location - floor(location);
        // float diff = ceil(location) - location;
        int index_one = floor(location);
        int index_two = index_one + 1;
        if (index_two > colors.size() - 1)
            index_two = index_one;

        // if (flip_half && index_one < colors.size() / 2)
        // {
        //     int tmp = index_two;
        //     index_two = index_one;
        //     index_one = tmp;
        // }

        Pixel color_one = colors[index_one];
        Pixel color_two = colors[index_two];

        // if (flip_half && index_one < colors.size() / 2)
        // {
        //     return Pixel(color_two.r * (1.f - diff) + color_one.r * diff,
        //                  color_two.g * (1.f - diff) + color_one.g * diff,
        //                  color_two.b * (1.f - diff) + color_one.b * diff);
        // }

        return Pixel(color_one.r * (1.f - diff) + color_two.r * diff,
                     color_one.g * (1.f - diff) + color_two.g * diff,
                     color_one.b * (1.f - diff) + color_two.b * diff);
    }

    static void color_map_inferno(std::vector<Pixel> &colors)
    {
        colors.push_back(Pixel(1.46159096e-03, 4.66127766e-04, 1.38655200e-02));
        colors.push_back(Pixel(2.26726368e-03, 1.26992553e-03, 1.85703520e-02));
        colors.push_back(Pixel(3.29899092e-03, 2.24934863e-03, 2.42390508e-02));
        colors.push_back(Pixel(4.54690615e-03, 3.39180156e-03, 3.09092475e-02));
        colors.push_back(Pixel(6.00552565e-03, 4.69194561e-03, 3.85578980e-02));
        colors.push_back(Pixel(7.67578856e-03, 6.13611626e-03, 4.68360336e-02));
        colors.push_back(Pixel(9.56051094e-03, 7.71344131e-03, 5.51430756e-02));
        colors.push_back(Pixel(1.16634769e-02, 9.41675403e-03, 6.34598080e-02));
        colors.push_back(Pixel(1.39950388e-02, 1.12247138e-02, 7.18616890e-02));
        colors.push_back(Pixel(1.65605595e-02, 1.31362262e-02, 8.02817951e-02));
        colors.push_back(Pixel(1.93732295e-02, 1.51325789e-02, 8.87668094e-02));
        colors.push_back(Pixel(2.24468865e-02, 1.71991484e-02, 9.73274383e-02));
        colors.push_back(Pixel(2.57927373e-02, 1.93306298e-02, 1.05929835e-01));
        colors.push_back(Pixel(2.94324251e-02, 2.15030771e-02, 1.14621328e-01));
        colors.push_back(Pixel(3.33852235e-02, 2.37024271e-02, 1.23397286e-01));
        colors.push_back(Pixel(3.76684211e-02, 2.59207864e-02, 1.32232108e-01));
        colors.push_back(Pixel(4.22525554e-02, 2.81385015e-02, 1.41140519e-01));
        colors.push_back(Pixel(4.69146287e-02, 3.03236129e-02, 1.50163867e-01));
        colors.push_back(Pixel(5.16437624e-02, 3.24736172e-02, 1.59254277e-01));
        colors.push_back(Pixel(5.64491009e-02, 3.45691867e-02, 1.68413539e-01));
        colors.push_back(Pixel(6.13397200e-02, 3.65900213e-02, 1.77642172e-01));
        colors.push_back(Pixel(6.63312620e-02, 3.85036268e-02, 1.86961588e-01));
        colors.push_back(Pixel(7.14289181e-02, 4.02939095e-02, 1.96353558e-01));
        colors.push_back(Pixel(7.66367560e-02, 4.19053329e-02, 2.05798788e-01));
        colors.push_back(Pixel(8.19620773e-02, 4.33278666e-02, 2.15289113e-01));
        colors.push_back(Pixel(8.74113897e-02, 4.45561662e-02, 2.24813479e-01));
        colors.push_back(Pixel(9.29901526e-02, 4.55829503e-02, 2.34357604e-01));
        colors.push_back(Pixel(9.87024972e-02, 4.64018731e-02, 2.43903700e-01));
        colors.push_back(Pixel(1.04550936e-01, 4.70080541e-02, 2.53430300e-01));
        colors.push_back(Pixel(1.10536084e-01, 4.73986708e-02, 2.62912235e-01));
        colors.push_back(Pixel(1.16656423e-01, 4.75735920e-02, 2.72320803e-01));
        colors.push_back(Pixel(1.22908126e-01, 4.75360183e-02, 2.81624170e-01));
        colors.push_back(Pixel(1.29284984e-01, 4.72930838e-02, 2.90788012e-01));
        colors.push_back(Pixel(1.35778450e-01, 4.68563678e-02, 2.99776404e-01));
        colors.push_back(Pixel(1.42377819e-01, 4.62422566e-02, 3.08552910e-01));
        colors.push_back(Pixel(1.49072957e-01, 4.54676444e-02, 3.17085139e-01));
        colors.push_back(Pixel(1.55849711e-01, 4.45588056e-02, 3.25338414e-01));
        colors.push_back(Pixel(1.62688939e-01, 4.35542881e-02, 3.33276678e-01));
        colors.push_back(Pixel(1.69575148e-01, 4.24893149e-02, 3.40874188e-01));
        colors.push_back(Pixel(1.76493202e-01, 4.14017089e-02, 3.48110606e-01));
        colors.push_back(Pixel(1.83428775e-01, 4.03288858e-02, 3.54971391e-01));
        colors.push_back(Pixel(1.90367453e-01, 3.93088888e-02, 3.61446945e-01));
        colors.push_back(Pixel(1.97297425e-01, 3.84001825e-02, 3.67534629e-01));
        colors.push_back(Pixel(2.04209298e-01, 3.76322609e-02, 3.73237557e-01));
        colors.push_back(Pixel(2.11095463e-01, 3.70296488e-02, 3.78563264e-01));
        colors.push_back(Pixel(2.17948648e-01, 3.66146049e-02, 3.83522415e-01));
        colors.push_back(Pixel(2.24762908e-01, 3.64049901e-02, 3.88128944e-01));
        colors.push_back(Pixel(2.31538148e-01, 3.64052511e-02, 3.92400150e-01));
        colors.push_back(Pixel(2.38272961e-01, 3.66209949e-02, 3.96353388e-01));
        colors.push_back(Pixel(2.44966911e-01, 3.70545017e-02, 4.00006615e-01));
        colors.push_back(Pixel(2.51620354e-01, 3.77052832e-02, 4.03377897e-01));
        colors.push_back(Pixel(2.58234265e-01, 3.85706153e-02, 4.06485031e-01));
        colors.push_back(Pixel(2.64809649e-01, 3.96468666e-02, 4.09345373e-01));
        colors.push_back(Pixel(2.71346664e-01, 4.09215821e-02, 4.11976086e-01));
        colors.push_back(Pixel(2.77849829e-01, 4.23528741e-02, 4.14392106e-01));
        colors.push_back(Pixel(2.84321318e-01, 4.39325787e-02, 4.16607861e-01));
        colors.push_back(Pixel(2.90763373e-01, 4.56437598e-02, 4.18636756e-01));
        colors.push_back(Pixel(2.97178251e-01, 4.74700293e-02, 4.20491164e-01));
        colors.push_back(Pixel(3.03568182e-01, 4.93958927e-02, 4.22182449e-01));
        colors.push_back(Pixel(3.09935342e-01, 5.14069729e-02, 4.23720999e-01));
        colors.push_back(Pixel(3.16281835e-01, 5.34901321e-02, 4.25116277e-01));
        colors.push_back(Pixel(3.22609671e-01, 5.56335178e-02, 4.26376869e-01));
        colors.push_back(Pixel(3.28920763e-01, 5.78265505e-02, 4.27510546e-01));
        colors.push_back(Pixel(3.35216916e-01, 6.00598734e-02, 4.28524320e-01));
        colors.push_back(Pixel(3.41499828e-01, 6.23252772e-02, 4.29424503e-01));
        colors.push_back(Pixel(3.47771086e-01, 6.46156100e-02, 4.30216765e-01));
        colors.push_back(Pixel(3.54032169e-01, 6.69246832e-02, 4.30906186e-01));
        colors.push_back(Pixel(3.60284449e-01, 6.92471753e-02, 4.31497309e-01));
        colors.push_back(Pixel(3.66529195e-01, 7.15785403e-02, 4.31994185e-01));
        colors.push_back(Pixel(3.72767575e-01, 7.39149211e-02, 4.32400419e-01));
        colors.push_back(Pixel(3.79000659e-01, 7.62530701e-02, 4.32719214e-01));
        colors.push_back(Pixel(3.85228383e-01, 7.85914864e-02, 4.32954973e-01));
        colors.push_back(Pixel(3.91452659e-01, 8.09267058e-02, 4.33108763e-01));
        colors.push_back(Pixel(3.97674379e-01, 8.32568129e-02, 4.33182647e-01));
        colors.push_back(Pixel(4.03894278e-01, 8.55803445e-02, 4.33178526e-01));
        colors.push_back(Pixel(4.10113015e-01, 8.78961593e-02, 4.33098056e-01));
        colors.push_back(Pixel(4.16331169e-01, 9.02033992e-02, 4.32942678e-01));
        colors.push_back(Pixel(4.22549249e-01, 9.25014543e-02, 4.32713635e-01));
        colors.push_back(Pixel(4.28767696e-01, 9.47899342e-02, 4.32411996e-01));
        colors.push_back(Pixel(4.34986885e-01, 9.70686417e-02, 4.32038673e-01));
        colors.push_back(Pixel(4.41207124e-01, 9.93375510e-02, 4.31594438e-01));
        colors.push_back(Pixel(4.47428382e-01, 1.01597079e-01, 4.31080497e-01));
        colors.push_back(Pixel(4.53650614e-01, 1.03847716e-01, 4.30497898e-01));
        colors.push_back(Pixel(4.59874623e-01, 1.06089165e-01, 4.29845789e-01));
        colors.push_back(Pixel(4.66100494e-01, 1.08321923e-01, 4.29124507e-01));
        colors.push_back(Pixel(4.72328255e-01, 1.10546584e-01, 4.28334320e-01));
        colors.push_back(Pixel(4.78557889e-01, 1.12763831e-01, 4.27475431e-01));
        colors.push_back(Pixel(4.84789325e-01, 1.14974430e-01, 4.26547991e-01));
        colors.push_back(Pixel(4.91022448e-01, 1.17179219e-01, 4.25552106e-01));
        colors.push_back(Pixel(4.97257069e-01, 1.19379132e-01, 4.24487908e-01));
        colors.push_back(Pixel(5.03492698e-01, 1.21575414e-01, 4.23356110e-01));
        colors.push_back(Pixel(5.09729541e-01, 1.23768654e-01, 4.22155676e-01));
        colors.push_back(Pixel(5.15967304e-01, 1.25959947e-01, 4.20886594e-01));
        colors.push_back(Pixel(5.22205646e-01, 1.28150439e-01, 4.19548848e-01));
        colors.push_back(Pixel(5.28444192e-01, 1.30341324e-01, 4.18142411e-01));
        colors.push_back(Pixel(5.34682523e-01, 1.32533845e-01, 4.16667258e-01));
        colors.push_back(Pixel(5.40920186e-01, 1.34729286e-01, 4.15123366e-01));
        colors.push_back(Pixel(5.47156706e-01, 1.36928959e-01, 4.13510662e-01));
        colors.push_back(Pixel(5.53391649e-01, 1.39134147e-01, 4.11828882e-01));
        colors.push_back(Pixel(5.59624442e-01, 1.41346265e-01, 4.10078028e-01));
        colors.push_back(Pixel(5.65854477e-01, 1.43566769e-01, 4.08258132e-01));
        colors.push_back(Pixel(5.72081108e-01, 1.45797150e-01, 4.06369246e-01));
        colors.push_back(Pixel(5.78303656e-01, 1.48038934e-01, 4.04411444e-01));
        colors.push_back(Pixel(5.84521407e-01, 1.50293679e-01, 4.02384829e-01));
        colors.push_back(Pixel(5.90733615e-01, 1.52562977e-01, 4.00289528e-01));
        colors.push_back(Pixel(5.96939751e-01, 1.54848232e-01, 3.98124897e-01));
        colors.push_back(Pixel(6.03138930e-01, 1.57151161e-01, 3.95891308e-01));
        colors.push_back(Pixel(6.09330184e-01, 1.59473549e-01, 3.93589349e-01));
        colors.push_back(Pixel(6.15512627e-01, 1.61817111e-01, 3.91219295e-01));
        colors.push_back(Pixel(6.21685340e-01, 1.64183582e-01, 3.88781456e-01));
        colors.push_back(Pixel(6.27847374e-01, 1.66574724e-01, 3.86276180e-01));
        colors.push_back(Pixel(6.33997746e-01, 1.68992314e-01, 3.83703854e-01));
        colors.push_back(Pixel(6.40135447e-01, 1.71438150e-01, 3.81064906e-01));
        colors.push_back(Pixel(6.46259648e-01, 1.73913876e-01, 3.78358969e-01));
        colors.push_back(Pixel(6.52369348e-01, 1.76421271e-01, 3.75586209e-01));
        colors.push_back(Pixel(6.58463166e-01, 1.78962399e-01, 3.72748214e-01));
        colors.push_back(Pixel(6.64539964e-01, 1.81539111e-01, 3.69845599e-01));
        colors.push_back(Pixel(6.70598572e-01, 1.84153268e-01, 3.66879025e-01));
        colors.push_back(Pixel(6.76637795e-01, 1.86806728e-01, 3.63849195e-01));
        colors.push_back(Pixel(6.82656407e-01, 1.89501352e-01, 3.60756856e-01));
        colors.push_back(Pixel(6.88653158e-01, 1.92238994e-01, 3.57602797e-01));
        colors.push_back(Pixel(6.94626769e-01, 1.95021500e-01, 3.54387853e-01));
        colors.push_back(Pixel(7.00575937e-01, 1.97850703e-01, 3.51112900e-01));
        colors.push_back(Pixel(7.06499709e-01, 2.00728196e-01, 3.47776863e-01));
        colors.push_back(Pixel(7.12396345e-01, 2.03656029e-01, 3.44382594e-01));
        colors.push_back(Pixel(7.18264447e-01, 2.06635993e-01, 3.40931208e-01));
        colors.push_back(Pixel(7.24102613e-01, 2.09669834e-01, 3.37423766e-01));
        colors.push_back(Pixel(7.29909422e-01, 2.12759270e-01, 3.33861367e-01));
        colors.push_back(Pixel(7.35683432e-01, 2.15905976e-01, 3.30245147e-01));
        colors.push_back(Pixel(7.41423185e-01, 2.19111589e-01, 3.26576275e-01));
        colors.push_back(Pixel(7.47127207e-01, 2.22377697e-01, 3.22855952e-01));
        colors.push_back(Pixel(7.52794009e-01, 2.25705837e-01, 3.19085410e-01));
        colors.push_back(Pixel(7.58422090e-01, 2.29097492e-01, 3.15265910e-01));
        colors.push_back(Pixel(7.64009940e-01, 2.32554083e-01, 3.11398734e-01));
        colors.push_back(Pixel(7.69556038e-01, 2.36076967e-01, 3.07485188e-01));
        colors.push_back(Pixel(7.75058888e-01, 2.39667435e-01, 3.03526312e-01));
        colors.push_back(Pixel(7.80517023e-01, 2.43326720e-01, 2.99522665e-01));
        colors.push_back(Pixel(7.85928794e-01, 2.47055968e-01, 2.95476756e-01));
        colors.push_back(Pixel(7.91292674e-01, 2.50856232e-01, 2.91389943e-01));
        colors.push_back(Pixel(7.96607144e-01, 2.54728485e-01, 2.87263585e-01));
        colors.push_back(Pixel(8.01870689e-01, 2.58673610e-01, 2.83099033e-01));
        colors.push_back(Pixel(8.07081807e-01, 2.62692401e-01, 2.78897629e-01));
        colors.push_back(Pixel(8.12239008e-01, 2.66785558e-01, 2.74660698e-01));
        colors.push_back(Pixel(8.17340818e-01, 2.70953688e-01, 2.70389545e-01));
        colors.push_back(Pixel(8.22385784e-01, 2.75197300e-01, 2.66085445e-01));
        colors.push_back(Pixel(8.27372474e-01, 2.79516805e-01, 2.61749643e-01));
        colors.push_back(Pixel(8.32299481e-01, 2.83912516e-01, 2.57383341e-01));
        colors.push_back(Pixel(8.37165425e-01, 2.88384647e-01, 2.52987700e-01));
        colors.push_back(Pixel(8.41968959e-01, 2.92933312e-01, 2.48563825e-01));
        colors.push_back(Pixel(8.46708768e-01, 2.97558528e-01, 2.44112767e-01));
        colors.push_back(Pixel(8.51383572e-01, 3.02260213e-01, 2.39635512e-01));
        colors.push_back(Pixel(8.55992130e-01, 3.07038188e-01, 2.35132978e-01));
        colors.push_back(Pixel(8.60533241e-01, 3.11892183e-01, 2.30606009e-01));
        colors.push_back(Pixel(8.65005747e-01, 3.16821833e-01, 2.26055368e-01));
        colors.push_back(Pixel(8.69408534e-01, 3.21826685e-01, 2.21481734e-01));
        colors.push_back(Pixel(8.73740530e-01, 3.26906201e-01, 2.16885699e-01));
        colors.push_back(Pixel(8.78000715e-01, 3.32059760e-01, 2.12267762e-01));
        colors.push_back(Pixel(8.82188112e-01, 3.37286663e-01, 2.07628326e-01));
        colors.push_back(Pixel(8.86301795e-01, 3.42586137e-01, 2.02967696e-01));
        colors.push_back(Pixel(8.90340885e-01, 3.47957340e-01, 1.98286080e-01));
        colors.push_back(Pixel(8.94304553e-01, 3.53399363e-01, 1.93583583e-01));
        colors.push_back(Pixel(8.98192017e-01, 3.58911240e-01, 1.88860212e-01));
        colors.push_back(Pixel(9.02002544e-01, 3.64491949e-01, 1.84115876e-01));
        colors.push_back(Pixel(9.05735448e-01, 3.70140419e-01, 1.79350388e-01));
        colors.push_back(Pixel(9.09390090e-01, 3.75855533e-01, 1.74563472e-01));
        colors.push_back(Pixel(9.12965874e-01, 3.81636138e-01, 1.69754764e-01));
        colors.push_back(Pixel(9.16462251e-01, 3.87481044e-01, 1.64923826e-01));
        colors.push_back(Pixel(9.19878710e-01, 3.93389034e-01, 1.60070152e-01));
        colors.push_back(Pixel(9.23214783e-01, 3.99358867e-01, 1.55193185e-01));
        colors.push_back(Pixel(9.26470039e-01, 4.05389282e-01, 1.50292329e-01));
        colors.push_back(Pixel(9.29644083e-01, 4.11479007e-01, 1.45366973e-01));
        colors.push_back(Pixel(9.32736555e-01, 4.17626756e-01, 1.40416519e-01));
        colors.push_back(Pixel(9.35747126e-01, 4.23831237e-01, 1.35440416e-01));
        colors.push_back(Pixel(9.38675494e-01, 4.30091162e-01, 1.30438175e-01));
        colors.push_back(Pixel(9.41521384e-01, 4.36405243e-01, 1.25409440e-01));
        colors.push_back(Pixel(9.44284543e-01, 4.42772199e-01, 1.20354038e-01));
        colors.push_back(Pixel(9.46964741e-01, 4.49190757e-01, 1.15272059e-01));
        colors.push_back(Pixel(9.49561766e-01, 4.55659658e-01, 1.10163947e-01));
        colors.push_back(Pixel(9.52075421e-01, 4.62177656e-01, 1.05030614e-01));
        colors.push_back(Pixel(9.54505523e-01, 4.68743522e-01, 9.98735931e-02));
        colors.push_back(Pixel(9.56851903e-01, 4.75356048e-01, 9.46952268e-02));
        colors.push_back(Pixel(9.59114397e-01, 4.82014044e-01, 8.94989073e-02));
        colors.push_back(Pixel(9.61292850e-01, 4.88716345e-01, 8.42893891e-02));
        colors.push_back(Pixel(9.63387110e-01, 4.95461806e-01, 7.90731907e-02));
        colors.push_back(Pixel(9.65397031e-01, 5.02249309e-01, 7.38591143e-02));
        colors.push_back(Pixel(9.67322465e-01, 5.09077761e-01, 6.86589199e-02));
        colors.push_back(Pixel(9.69163264e-01, 5.15946092e-01, 6.34881971e-02));
        colors.push_back(Pixel(9.70919277e-01, 5.22853259e-01, 5.83674890e-02));
        colors.push_back(Pixel(9.72590351e-01, 5.29798246e-01, 5.33237243e-02));
        colors.push_back(Pixel(9.74176327e-01, 5.36780059e-01, 4.83920090e-02));
        colors.push_back(Pixel(9.75677038e-01, 5.43797733e-01, 4.36177922e-02));
        colors.push_back(Pixel(9.77092313e-01, 5.50850323e-01, 3.90500131e-02));
        colors.push_back(Pixel(9.78421971e-01, 5.57936911e-01, 3.49306227e-02));
        colors.push_back(Pixel(9.79665824e-01, 5.65056600e-01, 3.14091591e-02));
        colors.push_back(Pixel(9.80823673e-01, 5.72208516e-01, 2.85075931e-02));
        colors.push_back(Pixel(9.81895311e-01, 5.79391803e-01, 2.62497353e-02));
        colors.push_back(Pixel(9.82880522e-01, 5.86605627e-01, 2.46613416e-02));
        colors.push_back(Pixel(9.83779081e-01, 5.93849168e-01, 2.37702263e-02));
        colors.push_back(Pixel(9.84590755e-01, 6.01121626e-01, 2.36063833e-02));
        colors.push_back(Pixel(9.85315301e-01, 6.08422211e-01, 2.42021174e-02));
        colors.push_back(Pixel(9.85952471e-01, 6.15750147e-01, 2.55921853e-02));
        colors.push_back(Pixel(9.86502013e-01, 6.23104667e-01, 2.78139496e-02));
        colors.push_back(Pixel(9.86963670e-01, 6.30485011e-01, 3.09075459e-02));
        colors.push_back(Pixel(9.87337182e-01, 6.37890424e-01, 3.49160639e-02));
        colors.push_back(Pixel(9.87622296e-01, 6.45320152e-01, 3.98857472e-02));
        colors.push_back(Pixel(9.87818759e-01, 6.52773439e-01, 4.55808037e-02));
        colors.push_back(Pixel(9.87926330e-01, 6.60249526e-01, 5.17503867e-02));
        colors.push_back(Pixel(9.87944783e-01, 6.67747641e-01, 5.83286889e-02));
        colors.push_back(Pixel(9.87873910e-01, 6.75267000e-01, 6.52570167e-02));
        colors.push_back(Pixel(9.87713535e-01, 6.82806802e-01, 7.24892330e-02));
        colors.push_back(Pixel(9.87463516e-01, 6.90366218e-01, 7.99897176e-02));
        colors.push_back(Pixel(9.87123759e-01, 6.97944391e-01, 8.77314215e-02));
        colors.push_back(Pixel(9.86694229e-01, 7.05540424e-01, 9.56941797e-02));
        colors.push_back(Pixel(9.86174970e-01, 7.13153375e-01, 1.03863324e-01));
        colors.push_back(Pixel(9.85565739e-01, 7.20782460e-01, 1.12228756e-01));
        colors.push_back(Pixel(9.84865203e-01, 7.28427497e-01, 1.20784651e-01));
        colors.push_back(Pixel(9.84075129e-01, 7.36086521e-01, 1.29526579e-01));
        colors.push_back(Pixel(9.83195992e-01, 7.43758326e-01, 1.38453063e-01));
        colors.push_back(Pixel(9.82228463e-01, 7.51441596e-01, 1.47564573e-01));
        colors.push_back(Pixel(9.81173457e-01, 7.59134892e-01, 1.56863224e-01));
        colors.push_back(Pixel(9.80032178e-01, 7.66836624e-01, 1.66352544e-01));
        colors.push_back(Pixel(9.78806183e-01, 7.74545028e-01, 1.76037298e-01));
        colors.push_back(Pixel(9.77497453e-01, 7.82258138e-01, 1.85923357e-01));
        colors.push_back(Pixel(9.76108474e-01, 7.89973753e-01, 1.96017589e-01));
        colors.push_back(Pixel(9.74637842e-01, 7.97691563e-01, 2.06331925e-01));
        colors.push_back(Pixel(9.73087939e-01, 8.05409333e-01, 2.16876839e-01));
        colors.push_back(Pixel(9.71467822e-01, 8.13121725e-01, 2.27658046e-01));
        colors.push_back(Pixel(9.69783146e-01, 8.20825143e-01, 2.38685942e-01));
        colors.push_back(Pixel(9.68040817e-01, 8.28515491e-01, 2.49971582e-01));
        colors.push_back(Pixel(9.66242589e-01, 8.36190976e-01, 2.61533898e-01));
        colors.push_back(Pixel(9.64393924e-01, 8.43848069e-01, 2.73391112e-01));
        colors.push_back(Pixel(9.62516656e-01, 8.51476340e-01, 2.85545675e-01));
        colors.push_back(Pixel(9.60625545e-01, 8.59068716e-01, 2.98010219e-01));
        colors.push_back(Pixel(9.58720088e-01, 8.66624355e-01, 3.10820466e-01));
        colors.push_back(Pixel(9.56834075e-01, 8.74128569e-01, 3.23973947e-01));
        colors.push_back(Pixel(9.54997177e-01, 8.81568926e-01, 3.37475479e-01));
        colors.push_back(Pixel(9.53215092e-01, 8.88942277e-01, 3.51368713e-01));
        colors.push_back(Pixel(9.51546225e-01, 8.96225909e-01, 3.65627005e-01));
        colors.push_back(Pixel(9.50018481e-01, 9.03409063e-01, 3.80271225e-01));
        colors.push_back(Pixel(9.48683391e-01, 9.10472964e-01, 3.95289169e-01));
        colors.push_back(Pixel(9.47594362e-01, 9.17399053e-01, 4.10665194e-01));
        colors.push_back(Pixel(9.46809163e-01, 9.24168246e-01, 4.26373236e-01));
        colors.push_back(Pixel(9.46391536e-01, 9.30760752e-01, 4.42367495e-01));
        colors.push_back(Pixel(9.46402951e-01, 9.37158971e-01, 4.58591507e-01));
        colors.push_back(Pixel(9.46902568e-01, 9.43347775e-01, 4.74969778e-01));
        colors.push_back(Pixel(9.47936825e-01, 9.49317522e-01, 4.91426053e-01));
        colors.push_back(Pixel(9.49544830e-01, 9.55062900e-01, 5.07859649e-01));
        colors.push_back(Pixel(9.51740304e-01, 9.60586693e-01, 5.24203026e-01));
        colors.push_back(Pixel(9.54529281e-01, 9.65895868e-01, 5.40360752e-01));
        colors.push_back(Pixel(9.57896053e-01, 9.71003330e-01, 5.56275090e-01));
        colors.push_back(Pixel(9.61812020e-01, 9.75924241e-01, 5.71925382e-01));
        colors.push_back(Pixel(9.66248822e-01, 9.80678193e-01, 5.87205773e-01));
        colors.push_back(Pixel(9.71161622e-01, 9.85282161e-01, 6.02154330e-01));
        colors.push_back(Pixel(9.76510983e-01, 9.89753437e-01, 6.16760413e-01));
        colors.push_back(Pixel(9.82257307e-01, 9.94108844e-01, 6.31017009e-01));
        colors.push_back(Pixel(9.88362068e-01, 9.98364143e-01, 6.44924005e-01));
    }

    static void color_map_magma(std::vector<Pixel> &colors)
    {
        colors.push_back(Pixel(1.46159096e-03, 4.66127766e-04, 1.38655200e-02));
        colors.push_back(Pixel(2.25764007e-03, 1.29495431e-03, 1.83311461e-02));
        colors.push_back(Pixel(3.27943222e-03, 2.30452991e-03, 2.37083291e-02));
        colors.push_back(Pixel(4.51230222e-03, 3.49037666e-03, 2.99647059e-02));
        colors.push_back(Pixel(5.94976987e-03, 4.84285000e-03, 3.71296695e-02));
        colors.push_back(Pixel(7.58798550e-03, 6.35613622e-03, 4.49730774e-02));
        colors.push_back(Pixel(9.42604390e-03, 8.02185006e-03, 5.28443561e-02));
        colors.push_back(Pixel(1.14654337e-02, 9.82831486e-03, 6.07496380e-02));
        colors.push_back(Pixel(1.37075706e-02, 1.17705913e-02, 6.86665843e-02));
        colors.push_back(Pixel(1.61557566e-02, 1.38404966e-02, 7.66026660e-02));
        colors.push_back(Pixel(1.88153670e-02, 1.60262753e-02, 8.45844897e-02));
        colors.push_back(Pixel(2.16919340e-02, 1.83201254e-02, 9.26101050e-02));
        colors.push_back(Pixel(2.47917814e-02, 2.07147875e-02, 1.00675555e-01));
        colors.push_back(Pixel(2.81228154e-02, 2.32009284e-02, 1.08786954e-01));
        colors.push_back(Pixel(3.16955304e-02, 2.57651161e-02, 1.16964722e-01));
        colors.push_back(Pixel(3.55204468e-02, 2.83974570e-02, 1.25209396e-01));
        colors.push_back(Pixel(3.96084872e-02, 3.10895652e-02, 1.33515085e-01));
        colors.push_back(Pixel(4.38295350e-02, 3.38299885e-02, 1.41886249e-01));
        colors.push_back(Pixel(4.80616391e-02, 3.66066101e-02, 1.50326989e-01));
        colors.push_back(Pixel(5.23204388e-02, 3.94066020e-02, 1.58841025e-01));
        colors.push_back(Pixel(5.66148978e-02, 4.21598925e-02, 1.67445592e-01));
        colors.push_back(Pixel(6.09493930e-02, 4.47944924e-02, 1.76128834e-01));
        colors.push_back(Pixel(6.53301801e-02, 4.73177796e-02, 1.84891506e-01));
        colors.push_back(Pixel(6.97637296e-02, 4.97264666e-02, 1.93735088e-01));
        colors.push_back(Pixel(7.42565152e-02, 5.20167766e-02, 2.02660374e-01));
        colors.push_back(Pixel(7.88150034e-02, 5.41844801e-02, 2.11667355e-01));
        colors.push_back(Pixel(8.34456313e-02, 5.62249365e-02, 2.20755099e-01));
        colors.push_back(Pixel(8.81547730e-02, 5.81331465e-02, 2.29921611e-01));
        colors.push_back(Pixel(9.29486914e-02, 5.99038167e-02, 2.39163669e-01));
        colors.push_back(Pixel(9.78334770e-02, 6.15314414e-02, 2.48476662e-01));
        colors.push_back(Pixel(1.02814972e-01, 6.30104053e-02, 2.57854400e-01));
        colors.push_back(Pixel(1.07898679e-01, 6.43351102e-02, 2.67288933e-01));
        colors.push_back(Pixel(1.13094451e-01, 6.54920358e-02, 2.76783978e-01));
        colors.push_back(Pixel(1.18405035e-01, 6.64791593e-02, 2.86320656e-01));
        colors.push_back(Pixel(1.23832651e-01, 6.72946449e-02, 2.95879431e-01));
        colors.push_back(Pixel(1.29380192e-01, 6.79349264e-02, 3.05442931e-01));
        colors.push_back(Pixel(1.35053322e-01, 6.83912798e-02, 3.14999890e-01));
        colors.push_back(Pixel(1.40857952e-01, 6.86540710e-02, 3.24537640e-01));
        colors.push_back(Pixel(1.46785234e-01, 6.87382323e-02, 3.34011109e-01));
        colors.push_back(Pixel(1.52839217e-01, 6.86368599e-02, 3.43404450e-01));
        colors.push_back(Pixel(1.59017511e-01, 6.83540225e-02, 3.52688028e-01));
        colors.push_back(Pixel(1.65308131e-01, 6.79108689e-02, 3.61816426e-01));
        colors.push_back(Pixel(1.71713033e-01, 6.73053260e-02, 3.70770827e-01));
        colors.push_back(Pixel(1.78211730e-01, 6.65758073e-02, 3.79497161e-01));
        colors.push_back(Pixel(1.84800877e-01, 6.57324381e-02, 3.87972507e-01));
        colors.push_back(Pixel(1.91459745e-01, 6.48183312e-02, 3.96151969e-01));
        colors.push_back(Pixel(1.98176877e-01, 6.38624166e-02, 4.04008953e-01));
        colors.push_back(Pixel(2.04934882e-01, 6.29066192e-02, 4.11514273e-01));
        colors.push_back(Pixel(2.11718061e-01, 6.19917876e-02, 4.18646741e-01));
        colors.push_back(Pixel(2.18511590e-01, 6.11584918e-02, 4.25391816e-01));
        colors.push_back(Pixel(2.25302032e-01, 6.04451843e-02, 4.31741767e-01));
        colors.push_back(Pixel(2.32076515e-01, 5.98886855e-02, 4.37694665e-01));
        colors.push_back(Pixel(2.38825991e-01, 5.95170384e-02, 4.43255999e-01));
        colors.push_back(Pixel(2.45543175e-01, 5.93524384e-02, 4.48435938e-01));
        colors.push_back(Pixel(2.52220252e-01, 5.94147119e-02, 4.53247729e-01));
        colors.push_back(Pixel(2.58857304e-01, 5.97055998e-02, 4.57709924e-01));
        colors.push_back(Pixel(2.65446744e-01, 6.02368754e-02, 4.61840297e-01));
        colors.push_back(Pixel(2.71994089e-01, 6.09935552e-02, 4.65660375e-01));
        colors.push_back(Pixel(2.78493300e-01, 6.19778136e-02, 4.69190328e-01));
        colors.push_back(Pixel(2.84951097e-01, 6.31676261e-02, 4.72450879e-01));
        colors.push_back(Pixel(2.91365817e-01, 6.45534486e-02, 4.75462193e-01));
        colors.push_back(Pixel(2.97740413e-01, 6.61170432e-02, 4.78243482e-01));
        colors.push_back(Pixel(3.04080941e-01, 6.78353452e-02, 4.80811572e-01));
        colors.push_back(Pixel(3.10382027e-01, 6.97024767e-02, 4.83186340e-01));
        colors.push_back(Pixel(3.16654235e-01, 7.16895272e-02, 4.85380429e-01));
        colors.push_back(Pixel(3.22899126e-01, 7.37819504e-02, 4.87408399e-01));
        colors.push_back(Pixel(3.29114038e-01, 7.59715081e-02, 4.89286796e-01));
        colors.push_back(Pixel(3.35307503e-01, 7.82361045e-02, 4.91024144e-01));
        colors.push_back(Pixel(3.41481725e-01, 8.05635079e-02, 4.92631321e-01));
        colors.push_back(Pixel(3.47635742e-01, 8.29463512e-02, 4.94120923e-01));
        colors.push_back(Pixel(3.53773161e-01, 8.53726329e-02, 4.95501096e-01));
        colors.push_back(Pixel(3.59897941e-01, 8.78311772e-02, 4.96778331e-01));
        colors.push_back(Pixel(3.66011928e-01, 9.03143031e-02, 4.97959963e-01));
        colors.push_back(Pixel(3.72116205e-01, 9.28159917e-02, 4.99053326e-01));
        colors.push_back(Pixel(3.78210547e-01, 9.53322947e-02, 5.00066568e-01));
        colors.push_back(Pixel(3.84299445e-01, 9.78549106e-02, 5.01001964e-01));
        colors.push_back(Pixel(3.90384361e-01, 1.00379466e-01, 5.01864236e-01));
        colors.push_back(Pixel(3.96466670e-01, 1.02902194e-01, 5.02657590e-01));
        colors.push_back(Pixel(4.02547663e-01, 1.05419865e-01, 5.03385761e-01));
        colors.push_back(Pixel(4.08628505e-01, 1.07929771e-01, 5.04052118e-01));
        colors.push_back(Pixel(4.14708664e-01, 1.10431177e-01, 5.04661843e-01));
        colors.push_back(Pixel(4.20791157e-01, 1.12920210e-01, 5.05214935e-01));
        colors.push_back(Pixel(4.26876965e-01, 1.15395258e-01, 5.05713602e-01));
        colors.push_back(Pixel(4.32967001e-01, 1.17854987e-01, 5.06159754e-01));
        colors.push_back(Pixel(4.39062114e-01, 1.20298314e-01, 5.06555026e-01));
        colors.push_back(Pixel(4.45163096e-01, 1.22724371e-01, 5.06900806e-01));
        colors.push_back(Pixel(4.51270678e-01, 1.25132484e-01, 5.07198258e-01));
        colors.push_back(Pixel(4.57385535e-01, 1.27522145e-01, 5.07448336e-01));
        colors.push_back(Pixel(4.63508291e-01, 1.29892998e-01, 5.07651812e-01));
        colors.push_back(Pixel(4.69639514e-01, 1.32244819e-01, 5.07809282e-01));
        colors.push_back(Pixel(4.75779723e-01, 1.34577500e-01, 5.07921193e-01));
        colors.push_back(Pixel(4.81928997e-01, 1.36891390e-01, 5.07988509e-01));
        colors.push_back(Pixel(4.88088169e-01, 1.39186217e-01, 5.08010737e-01));
        colors.push_back(Pixel(4.94257673e-01, 1.41462106e-01, 5.07987836e-01));
        colors.push_back(Pixel(5.00437834e-01, 1.43719323e-01, 5.07919772e-01));
        colors.push_back(Pixel(5.06628929e-01, 1.45958202e-01, 5.07806420e-01));
        colors.push_back(Pixel(5.12831195e-01, 1.48179144e-01, 5.07647570e-01));
        colors.push_back(Pixel(5.19044825e-01, 1.50382611e-01, 5.07442938e-01));
        colors.push_back(Pixel(5.25269968e-01, 1.52569121e-01, 5.07192172e-01));
        colors.push_back(Pixel(5.31506735e-01, 1.54739247e-01, 5.06894860e-01));
        colors.push_back(Pixel(5.37755194e-01, 1.56893613e-01, 5.06550538e-01));
        colors.push_back(Pixel(5.44015371e-01, 1.59032895e-01, 5.06158696e-01));
        colors.push_back(Pixel(5.50287252e-01, 1.61157816e-01, 5.05718782e-01));
        colors.push_back(Pixel(5.56570783e-01, 1.63269149e-01, 5.05230210e-01));
        colors.push_back(Pixel(5.62865867e-01, 1.65367714e-01, 5.04692365e-01));
        colors.push_back(Pixel(5.69172368e-01, 1.67454379e-01, 5.04104606e-01));
        colors.push_back(Pixel(5.75490107e-01, 1.69530062e-01, 5.03466273e-01));
        colors.push_back(Pixel(5.81818864e-01, 1.71595728e-01, 5.02776690e-01));
        colors.push_back(Pixel(5.88158375e-01, 1.73652392e-01, 5.02035167e-01));
        colors.push_back(Pixel(5.94508337e-01, 1.75701122e-01, 5.01241011e-01));
        colors.push_back(Pixel(6.00868399e-01, 1.77743036e-01, 5.00393522e-01));
        colors.push_back(Pixel(6.07238169e-01, 1.79779309e-01, 4.99491999e-01));
        colors.push_back(Pixel(6.13617209e-01, 1.81811170e-01, 4.98535746e-01));
        colors.push_back(Pixel(6.20005032e-01, 1.83839907e-01, 4.97524075e-01));
        colors.push_back(Pixel(6.26401108e-01, 1.85866869e-01, 4.96456304e-01));
        colors.push_back(Pixel(6.32804854e-01, 1.87893468e-01, 4.95331769e-01));
        colors.push_back(Pixel(6.39215638e-01, 1.89921182e-01, 4.94149821e-01));
        colors.push_back(Pixel(6.45632778e-01, 1.91951556e-01, 4.92909832e-01));
        colors.push_back(Pixel(6.52055535e-01, 1.93986210e-01, 4.91611196e-01));
        colors.push_back(Pixel(6.58483116e-01, 1.96026835e-01, 4.90253338e-01));
        colors.push_back(Pixel(6.64914668e-01, 1.98075202e-01, 4.88835712e-01));
        colors.push_back(Pixel(6.71349279e-01, 2.00133166e-01, 4.87357807e-01));
        colors.push_back(Pixel(6.77785975e-01, 2.02202663e-01, 4.85819154e-01));
        colors.push_back(Pixel(6.84223712e-01, 2.04285721e-01, 4.84219325e-01));
        colors.push_back(Pixel(6.90661380e-01, 2.06384461e-01, 4.82557941e-01));
        colors.push_back(Pixel(6.97097796e-01, 2.08501100e-01, 4.80834678e-01));
        colors.push_back(Pixel(7.03531700e-01, 2.10637956e-01, 4.79049270e-01));
        colors.push_back(Pixel(7.09961888e-01, 2.12797337e-01, 4.77201121e-01));
        colors.push_back(Pixel(7.16387038e-01, 2.14981693e-01, 4.75289780e-01));
        colors.push_back(Pixel(7.22805451e-01, 2.17193831e-01, 4.73315708e-01));
        colors.push_back(Pixel(7.29215521e-01, 2.19436516e-01, 4.71278924e-01));
        colors.push_back(Pixel(7.35615545e-01, 2.21712634e-01, 4.69179541e-01));
        colors.push_back(Pixel(7.42003713e-01, 2.24025196e-01, 4.67017774e-01));
        colors.push_back(Pixel(7.48378107e-01, 2.26377345e-01, 4.64793954e-01));
        colors.push_back(Pixel(7.54736692e-01, 2.28772352e-01, 4.62508534e-01));
        colors.push_back(Pixel(7.61077312e-01, 2.31213625e-01, 4.60162106e-01));
        colors.push_back(Pixel(7.67397681e-01, 2.33704708e-01, 4.57755411e-01));
        colors.push_back(Pixel(7.73695380e-01, 2.36249283e-01, 4.55289354e-01));
        colors.push_back(Pixel(7.79967847e-01, 2.38851170e-01, 4.52765022e-01));
        colors.push_back(Pixel(7.86212372e-01, 2.41514325e-01, 4.50183695e-01));
        colors.push_back(Pixel(7.92426972e-01, 2.44242250e-01, 4.47543155e-01));
        colors.push_back(Pixel(7.98607760e-01, 2.47039798e-01, 4.44848441e-01));
        colors.push_back(Pixel(8.04751511e-01, 2.49911350e-01, 4.42101615e-01));
        colors.push_back(Pixel(8.10854841e-01, 2.52861399e-01, 4.39304963e-01));
        colors.push_back(Pixel(8.16914186e-01, 2.55894550e-01, 4.36461074e-01));
        colors.push_back(Pixel(8.22925797e-01, 2.59015505e-01, 4.33572874e-01));
        colors.push_back(Pixel(8.28885740e-01, 2.62229049e-01, 4.30643647e-01));
        colors.push_back(Pixel(8.34790818e-01, 2.65539703e-01, 4.27671352e-01));
        colors.push_back(Pixel(8.40635680e-01, 2.68952874e-01, 4.24665620e-01));
        colors.push_back(Pixel(8.46415804e-01, 2.72473491e-01, 4.21631064e-01));
        colors.push_back(Pixel(8.52126490e-01, 2.76106469e-01, 4.18572767e-01));
        colors.push_back(Pixel(8.57762870e-01, 2.79856666e-01, 4.15496319e-01));
        colors.push_back(Pixel(8.63320397e-01, 2.83729003e-01, 4.12402889e-01));
        colors.push_back(Pixel(8.68793368e-01, 2.87728205e-01, 4.09303002e-01));
        colors.push_back(Pixel(8.74176342e-01, 2.91858679e-01, 4.06205397e-01));
        colors.push_back(Pixel(8.79463944e-01, 2.96124596e-01, 4.03118034e-01));
        colors.push_back(Pixel(8.84650824e-01, 3.00530090e-01, 4.00047060e-01));
        colors.push_back(Pixel(8.89731418e-01, 3.05078817e-01, 3.97001559e-01));
        colors.push_back(Pixel(8.94700194e-01, 3.09773445e-01, 3.93994634e-01));
        colors.push_back(Pixel(8.99551884e-01, 3.14616425e-01, 3.91036674e-01));
        colors.push_back(Pixel(9.04281297e-01, 3.19609981e-01, 3.88136889e-01));
        colors.push_back(Pixel(9.08883524e-01, 3.24755126e-01, 3.85308008e-01));
        colors.push_back(Pixel(9.13354091e-01, 3.30051947e-01, 3.82563414e-01));
        colors.push_back(Pixel(9.17688852e-01, 3.35500068e-01, 3.79915138e-01));
        colors.push_back(Pixel(9.21884187e-01, 3.41098112e-01, 3.77375977e-01));
        colors.push_back(Pixel(9.25937102e-01, 3.46843685e-01, 3.74959077e-01));
        colors.push_back(Pixel(9.29845090e-01, 3.52733817e-01, 3.72676513e-01));
        colors.push_back(Pixel(9.33606454e-01, 3.58764377e-01, 3.70540883e-01));
        colors.push_back(Pixel(9.37220874e-01, 3.64929312e-01, 3.68566525e-01));
        colors.push_back(Pixel(9.40687443e-01, 3.71224168e-01, 3.66761699e-01));
        colors.push_back(Pixel(9.44006448e-01, 3.77642889e-01, 3.65136328e-01));
        colors.push_back(Pixel(9.47179528e-01, 3.84177874e-01, 3.63701130e-01));
        colors.push_back(Pixel(9.50210150e-01, 3.90819546e-01, 3.62467694e-01));
        colors.push_back(Pixel(9.53099077e-01, 3.97562894e-01, 3.61438431e-01));
        colors.push_back(Pixel(9.55849237e-01, 4.04400213e-01, 3.60619076e-01));
        colors.push_back(Pixel(9.58464079e-01, 4.11323666e-01, 3.60014232e-01));
        colors.push_back(Pixel(9.60949221e-01, 4.18323245e-01, 3.59629789e-01));
        colors.push_back(Pixel(9.63310281e-01, 4.25389724e-01, 3.59469020e-01));
        colors.push_back(Pixel(9.65549351e-01, 4.32518707e-01, 3.59529151e-01));
        colors.push_back(Pixel(9.67671128e-01, 4.39702976e-01, 3.59810172e-01));
        colors.push_back(Pixel(9.69680441e-01, 4.46935635e-01, 3.60311120e-01));
        colors.push_back(Pixel(9.71582181e-01, 4.54210170e-01, 3.61030156e-01));
        colors.push_back(Pixel(9.73381238e-01, 4.61520484e-01, 3.61964652e-01));
        colors.push_back(Pixel(9.75082439e-01, 4.68860936e-01, 3.63111292e-01));
        colors.push_back(Pixel(9.76690494e-01, 4.76226350e-01, 3.64466162e-01));
        colors.push_back(Pixel(9.78209957e-01, 4.83612031e-01, 3.66024854e-01));
        colors.push_back(Pixel(9.79645181e-01, 4.91013764e-01, 3.67782559e-01));
        colors.push_back(Pixel(9.81000291e-01, 4.98427800e-01, 3.69734157e-01));
        colors.push_back(Pixel(9.82279159e-01, 5.05850848e-01, 3.71874301e-01));
        colors.push_back(Pixel(9.83485387e-01, 5.13280054e-01, 3.74197501e-01));
        colors.push_back(Pixel(9.84622298e-01, 5.20712972e-01, 3.76698186e-01));
        colors.push_back(Pixel(9.85692925e-01, 5.28147545e-01, 3.79370774e-01));
        colors.push_back(Pixel(9.86700017e-01, 5.35582070e-01, 3.82209724e-01));
        colors.push_back(Pixel(9.87646038e-01, 5.43015173e-01, 3.85209578e-01));
        colors.push_back(Pixel(9.88533173e-01, 5.50445778e-01, 3.88365009e-01));
        colors.push_back(Pixel(9.89363341e-01, 5.57873075e-01, 3.91670846e-01));
        colors.push_back(Pixel(9.90138201e-01, 5.65296495e-01, 3.95122099e-01));
        colors.push_back(Pixel(9.90871208e-01, 5.72706259e-01, 3.98713971e-01));
        colors.push_back(Pixel(9.91558165e-01, 5.80106828e-01, 4.02441058e-01));
        colors.push_back(Pixel(9.92195728e-01, 5.87501706e-01, 4.06298792e-01));
        colors.push_back(Pixel(9.92784669e-01, 5.94891088e-01, 4.10282976e-01));
        colors.push_back(Pixel(9.93325561e-01, 6.02275297e-01, 4.14389658e-01));
        colors.push_back(Pixel(9.93834412e-01, 6.09643540e-01, 4.18613221e-01));
        colors.push_back(Pixel(9.94308514e-01, 6.16998953e-01, 4.22949672e-01));
        colors.push_back(Pixel(9.94737698e-01, 6.24349657e-01, 4.27396771e-01));
        colors.push_back(Pixel(9.95121854e-01, 6.31696376e-01, 4.31951492e-01));
        colors.push_back(Pixel(9.95480469e-01, 6.39026596e-01, 4.36607159e-01));
        colors.push_back(Pixel(9.95809924e-01, 6.46343897e-01, 4.41360951e-01));
        colors.push_back(Pixel(9.96095703e-01, 6.53658756e-01, 4.46213021e-01));
        colors.push_back(Pixel(9.96341406e-01, 6.60969379e-01, 4.51160201e-01));
        colors.push_back(Pixel(9.96579803e-01, 6.68255621e-01, 4.56191814e-01));
        colors.push_back(Pixel(9.96774784e-01, 6.75541484e-01, 4.61314158e-01));
        colors.push_back(Pixel(9.96925427e-01, 6.82827953e-01, 4.66525689e-01));
        colors.push_back(Pixel(9.97077185e-01, 6.90087897e-01, 4.71811461e-01));
        colors.push_back(Pixel(9.97186253e-01, 6.97348991e-01, 4.77181727e-01));
        colors.push_back(Pixel(9.97253982e-01, 7.04610791e-01, 4.82634651e-01));
        colors.push_back(Pixel(9.97325180e-01, 7.11847714e-01, 4.88154375e-01));
        colors.push_back(Pixel(9.97350983e-01, 7.19089119e-01, 4.93754665e-01));
        colors.push_back(Pixel(9.97350583e-01, 7.26324415e-01, 4.99427972e-01));
        colors.push_back(Pixel(9.97341259e-01, 7.33544671e-01, 5.05166839e-01));
        colors.push_back(Pixel(9.97284689e-01, 7.40771893e-01, 5.10983331e-01));
        colors.push_back(Pixel(9.97228367e-01, 7.47980563e-01, 5.16859378e-01));
        colors.push_back(Pixel(9.97138480e-01, 7.55189852e-01, 5.22805996e-01));
        colors.push_back(Pixel(9.97019342e-01, 7.62397883e-01, 5.28820775e-01));
        colors.push_back(Pixel(9.96898254e-01, 7.69590975e-01, 5.34892341e-01));
        colors.push_back(Pixel(9.96726862e-01, 7.76794860e-01, 5.41038571e-01));
        colors.push_back(Pixel(9.96570645e-01, 7.83976508e-01, 5.47232992e-01));
        colors.push_back(Pixel(9.96369065e-01, 7.91167346e-01, 5.53498939e-01));
        colors.push_back(Pixel(9.96162309e-01, 7.98347709e-01, 5.59819643e-01));
        colors.push_back(Pixel(9.95932448e-01, 8.05527126e-01, 5.66201824e-01));
        colors.push_back(Pixel(9.95680107e-01, 8.12705773e-01, 5.72644795e-01));
        colors.push_back(Pixel(9.95423973e-01, 8.19875302e-01, 5.79140130e-01));
        colors.push_back(Pixel(9.95131288e-01, 8.27051773e-01, 5.85701463e-01));
        colors.push_back(Pixel(9.94851089e-01, 8.34212826e-01, 5.92307093e-01));
        colors.push_back(Pixel(9.94523666e-01, 8.41386618e-01, 5.98982818e-01));
        colors.push_back(Pixel(9.94221900e-01, 8.48540474e-01, 6.05695903e-01));
        colors.push_back(Pixel(9.93865767e-01, 8.55711038e-01, 6.12481798e-01));
        colors.push_back(Pixel(9.93545285e-01, 8.62858846e-01, 6.19299300e-01));
        colors.push_back(Pixel(9.93169558e-01, 8.70024467e-01, 6.26189463e-01));
        colors.push_back(Pixel(9.92830963e-01, 8.77168404e-01, 6.33109148e-01));
        colors.push_back(Pixel(9.92439881e-01, 8.84329694e-01, 6.40099465e-01));
        colors.push_back(Pixel(9.92089454e-01, 8.91469549e-01, 6.47116021e-01));
        colors.push_back(Pixel(9.91687744e-01, 8.98627050e-01, 6.54201544e-01));
        colors.push_back(Pixel(9.91331929e-01, 9.05762748e-01, 6.61308839e-01));
        colors.push_back(Pixel(9.90929685e-01, 9.12915010e-01, 6.68481201e-01));
        colors.push_back(Pixel(9.90569914e-01, 9.20048699e-01, 6.75674592e-01));
        colors.push_back(Pixel(9.90174637e-01, 9.27195612e-01, 6.82925602e-01));
        colors.push_back(Pixel(9.89814839e-01, 9.34328540e-01, 6.90198194e-01));
        colors.push_back(Pixel(9.89433736e-01, 9.41470354e-01, 6.97518628e-01));
        colors.push_back(Pixel(9.89077438e-01, 9.48604077e-01, 7.04862519e-01));
        colors.push_back(Pixel(9.88717064e-01, 9.55741520e-01, 7.12242232e-01));
        colors.push_back(Pixel(9.88367028e-01, 9.62878026e-01, 7.19648627e-01));
        colors.push_back(Pixel(9.88032885e-01, 9.70012413e-01, 7.27076773e-01));
        colors.push_back(Pixel(9.87690702e-01, 9.77154231e-01, 7.34536205e-01));
        colors.push_back(Pixel(9.87386827e-01, 9.84287561e-01, 7.42001547e-01));
        colors.push_back(Pixel(9.87052509e-01, 9.91437853e-01, 7.49504188e-01));
    }

    static void color_map_plasma(std::vector<Pixel> &colors)
    {
        colors.push_back(Pixel(5.03832136e-02, 2.98028976e-02, 5.27974883e-01));
        colors.push_back(Pixel(6.35363639e-02, 2.84259729e-02, 5.33123681e-01));
        colors.push_back(Pixel(7.53531234e-02, 2.72063728e-02, 5.38007001e-01));
        colors.push_back(Pixel(8.62217979e-02, 2.61253206e-02, 5.42657691e-01));
        colors.push_back(Pixel(9.63786097e-02, 2.51650976e-02, 5.47103487e-01));
        colors.push_back(Pixel(1.05979704e-01, 2.43092436e-02, 5.51367851e-01));
        colors.push_back(Pixel(1.15123641e-01, 2.35562500e-02, 5.55467728e-01));
        colors.push_back(Pixel(1.23902903e-01, 2.28781011e-02, 5.59423480e-01));
        colors.push_back(Pixel(1.32380720e-01, 2.22583774e-02, 5.63250116e-01));
        colors.push_back(Pixel(1.40603076e-01, 2.16866674e-02, 5.66959485e-01));
        colors.push_back(Pixel(1.48606527e-01, 2.11535876e-02, 5.70561711e-01));
        colors.push_back(Pixel(1.56420649e-01, 2.06507174e-02, 5.74065446e-01));
        colors.push_back(Pixel(1.64069722e-01, 2.01705326e-02, 5.77478074e-01));
        colors.push_back(Pixel(1.71573925e-01, 1.97063415e-02, 5.80805890e-01));
        colors.push_back(Pixel(1.78950212e-01, 1.92522243e-02, 5.84054243e-01));
        colors.push_back(Pixel(1.86212958e-01, 1.88029767e-02, 5.87227661e-01));
        colors.push_back(Pixel(1.93374449e-01, 1.83540593e-02, 5.90329954e-01));
        colors.push_back(Pixel(2.00445260e-01, 1.79015512e-02, 5.93364304e-01));
        colors.push_back(Pixel(2.07434551e-01, 1.74421086e-02, 5.96333341e-01));
        colors.push_back(Pixel(2.14350298e-01, 1.69729276e-02, 5.99239207e-01));
        colors.push_back(Pixel(2.21196750e-01, 1.64970484e-02, 6.02083323e-01));
        colors.push_back(Pixel(2.27982971e-01, 1.60071509e-02, 6.04867403e-01));
        colors.push_back(Pixel(2.34714537e-01, 1.55015065e-02, 6.07592438e-01));
        colors.push_back(Pixel(2.41396253e-01, 1.49791041e-02, 6.10259089e-01));
        colors.push_back(Pixel(2.48032377e-01, 1.44393586e-02, 6.12867743e-01));
        colors.push_back(Pixel(2.54626690e-01, 1.38820918e-02, 6.15418537e-01));
        colors.push_back(Pixel(2.61182562e-01, 1.33075156e-02, 6.17911385e-01));
        colors.push_back(Pixel(2.67702993e-01, 1.27162163e-02, 6.20345997e-01));
        colors.push_back(Pixel(2.74190665e-01, 1.21091423e-02, 6.22721903e-01));
        colors.push_back(Pixel(2.80647969e-01, 1.14875915e-02, 6.25038468e-01));
        colors.push_back(Pixel(2.87076059e-01, 1.08554862e-02, 6.27294975e-01));
        colors.push_back(Pixel(2.93477695e-01, 1.02128849e-02, 6.29490490e-01));
        colors.push_back(Pixel(2.99855122e-01, 9.56079551e-03, 6.31623923e-01));
        colors.push_back(Pixel(3.06209825e-01, 8.90185346e-03, 6.33694102e-01));
        colors.push_back(Pixel(3.12543124e-01, 8.23900704e-03, 6.35699759e-01));
        colors.push_back(Pixel(3.18856183e-01, 7.57551051e-03, 6.37639537e-01));
        colors.push_back(Pixel(3.25150025e-01, 6.91491734e-03, 6.39512001e-01));
        colors.push_back(Pixel(3.31425547e-01, 6.26107379e-03, 6.41315649e-01));
        colors.push_back(Pixel(3.37683446e-01, 5.61830889e-03, 6.43048936e-01));
        colors.push_back(Pixel(3.43924591e-01, 4.99053080e-03, 6.44710195e-01));
        colors.push_back(Pixel(3.50149699e-01, 4.38202557e-03, 6.46297711e-01));
        colors.push_back(Pixel(3.56359209e-01, 3.79781761e-03, 6.47809772e-01));
        colors.push_back(Pixel(3.62553473e-01, 3.24319591e-03, 6.49244641e-01));
        colors.push_back(Pixel(3.68732762e-01, 2.72370721e-03, 6.50600561e-01));
        colors.push_back(Pixel(3.74897270e-01, 2.24514897e-03, 6.51875762e-01));
        colors.push_back(Pixel(3.81047116e-01, 1.81356205e-03, 6.53068467e-01));
        colors.push_back(Pixel(3.87182639e-01, 1.43446923e-03, 6.54176761e-01));
        colors.push_back(Pixel(3.93304010e-01, 1.11388259e-03, 6.55198755e-01));
        colors.push_back(Pixel(3.99410821e-01, 8.59420809e-04, 6.56132835e-01));
        colors.push_back(Pixel(4.05502914e-01, 6.78091517e-04, 6.56977276e-01));
        colors.push_back(Pixel(4.11580082e-01, 5.77101735e-04, 6.57730380e-01));
        colors.push_back(Pixel(4.17642063e-01, 5.63847476e-04, 6.58390492e-01));
        colors.push_back(Pixel(4.23688549e-01, 6.45902780e-04, 6.58956004e-01));
        colors.push_back(Pixel(4.29719186e-01, 8.31008207e-04, 6.59425363e-01));
        colors.push_back(Pixel(4.35733575e-01, 1.12705875e-03, 6.59797077e-01));
        colors.push_back(Pixel(4.41732123e-01, 1.53984779e-03, 6.60069009e-01));
        colors.push_back(Pixel(4.47713600e-01, 2.07954744e-03, 6.60240367e-01));
        colors.push_back(Pixel(4.53677394e-01, 2.75470302e-03, 6.60309966e-01));
        colors.push_back(Pixel(4.59622938e-01, 3.57374415e-03, 6.60276655e-01));
        colors.push_back(Pixel(4.65549631e-01, 4.54518084e-03, 6.60139383e-01));
        colors.push_back(Pixel(4.71456847e-01, 5.67758762e-03, 6.59897210e-01));
        colors.push_back(Pixel(4.77343929e-01, 6.97958743e-03, 6.59549311e-01));
        colors.push_back(Pixel(4.83210198e-01, 8.45983494e-03, 6.59094989e-01));
        colors.push_back(Pixel(4.89054951e-01, 1.01269996e-02, 6.58533677e-01));
        colors.push_back(Pixel(4.94877466e-01, 1.19897486e-02, 6.57864946e-01));
        colors.push_back(Pixel(5.00677687e-01, 1.40550640e-02, 6.57087561e-01));
        colors.push_back(Pixel(5.06454143e-01, 1.63333443e-02, 6.56202294e-01));
        colors.push_back(Pixel(5.12206035e-01, 1.88332232e-02, 6.55209222e-01));
        colors.push_back(Pixel(5.17932580e-01, 2.15631918e-02, 6.54108545e-01));
        colors.push_back(Pixel(5.23632990e-01, 2.45316468e-02, 6.52900629e-01));
        colors.push_back(Pixel(5.29306474e-01, 2.77468735e-02, 6.51586010e-01));
        colors.push_back(Pixel(5.34952244e-01, 3.12170300e-02, 6.50165396e-01));
        colors.push_back(Pixel(5.40569510e-01, 3.49501310e-02, 6.48639668e-01));
        colors.push_back(Pixel(5.46157494e-01, 3.89540334e-02, 6.47009884e-01));
        colors.push_back(Pixel(5.51715423e-01, 4.31364795e-02, 6.45277275e-01));
        colors.push_back(Pixel(5.57242538e-01, 4.73307585e-02, 6.43443250e-01));
        colors.push_back(Pixel(5.62738096e-01, 5.15448092e-02, 6.41509389e-01));
        colors.push_back(Pixel(5.68201372e-01, 5.57776706e-02, 6.39477440e-01));
        colors.push_back(Pixel(5.73631859e-01, 6.00281369e-02, 6.37348841e-01));
        colors.push_back(Pixel(5.79028682e-01, 6.42955547e-02, 6.35126108e-01));
        colors.push_back(Pixel(5.84391137e-01, 6.85790261e-02, 6.32811608e-01));
        colors.push_back(Pixel(5.89718606e-01, 7.28775875e-02, 6.30407727e-01));
        colors.push_back(Pixel(5.95010505e-01, 7.71902878e-02, 6.27916992e-01));
        colors.push_back(Pixel(6.00266283e-01, 8.15161895e-02, 6.25342058e-01));
        colors.push_back(Pixel(6.05485428e-01, 8.58543713e-02, 6.22685703e-01));
        colors.push_back(Pixel(6.10667469e-01, 9.02039303e-02, 6.19950811e-01));
        colors.push_back(Pixel(6.15811974e-01, 9.45639838e-02, 6.17140367e-01));
        colors.push_back(Pixel(6.20918555e-01, 9.89336721e-02, 6.14257440e-01));
        colors.push_back(Pixel(6.25986869e-01, 1.03312160e-01, 6.11305174e-01));
        colors.push_back(Pixel(6.31016615e-01, 1.07698641e-01, 6.08286774e-01));
        colors.push_back(Pixel(6.36007543e-01, 1.12092335e-01, 6.05205491e-01));
        colors.push_back(Pixel(6.40959444e-01, 1.16492495e-01, 6.02064611e-01));
        colors.push_back(Pixel(6.45872158e-01, 1.20898405e-01, 5.98867442e-01));
        colors.push_back(Pixel(6.50745571e-01, 1.25309384e-01, 5.95617300e-01));
        colors.push_back(Pixel(6.55579615e-01, 1.29724785e-01, 5.92317494e-01));
        colors.push_back(Pixel(6.60374266e-01, 1.34143997e-01, 5.88971318e-01));
        colors.push_back(Pixel(6.65129493e-01, 1.38566428e-01, 5.85582301e-01));
        colors.push_back(Pixel(6.69845385e-01, 1.42991540e-01, 5.82153572e-01));
        colors.push_back(Pixel(6.74522060e-01, 1.47418835e-01, 5.78688247e-01));
        colors.push_back(Pixel(6.79159664e-01, 1.51847851e-01, 5.75189431e-01));
        colors.push_back(Pixel(6.83758384e-01, 1.56278163e-01, 5.71660158e-01));
        colors.push_back(Pixel(6.88318440e-01, 1.60709387e-01, 5.68103380e-01));
        colors.push_back(Pixel(6.92840088e-01, 1.65141174e-01, 5.64521958e-01));
        colors.push_back(Pixel(6.97323615e-01, 1.69573215e-01, 5.60918659e-01));
        colors.push_back(Pixel(7.01769334e-01, 1.74005236e-01, 5.57296144e-01));
        colors.push_back(Pixel(7.06177590e-01, 1.78437000e-01, 5.53656970e-01));
        colors.push_back(Pixel(7.10548747e-01, 1.82868306e-01, 5.50003579e-01));
        colors.push_back(Pixel(7.14883195e-01, 1.87298986e-01, 5.46338299e-01));
        colors.push_back(Pixel(7.19181339e-01, 1.91728906e-01, 5.42663338e-01));
        colors.push_back(Pixel(7.23443604e-01, 1.96157962e-01, 5.38980786e-01));
        colors.push_back(Pixel(7.27670428e-01, 2.00586086e-01, 5.35292612e-01));
        colors.push_back(Pixel(7.31862231e-01, 2.05013174e-01, 5.31600995e-01));
        colors.push_back(Pixel(7.36019424e-01, 2.09439071e-01, 5.27908434e-01));
        colors.push_back(Pixel(7.40142557e-01, 2.13863965e-01, 5.24215533e-01));
        colors.push_back(Pixel(7.44232102e-01, 2.18287899e-01, 5.20523766e-01));
        colors.push_back(Pixel(7.48288533e-01, 2.22710942e-01, 5.16834495e-01));
        colors.push_back(Pixel(7.52312321e-01, 2.27133187e-01, 5.13148963e-01));
        colors.push_back(Pixel(7.56303937e-01, 2.31554749e-01, 5.09468305e-01));
        colors.push_back(Pixel(7.60263849e-01, 2.35975765e-01, 5.05793543e-01));
        colors.push_back(Pixel(7.64192516e-01, 2.40396394e-01, 5.02125599e-01));
        colors.push_back(Pixel(7.68090391e-01, 2.44816813e-01, 4.98465290e-01));
        colors.push_back(Pixel(7.71957916e-01, 2.49237220e-01, 4.94813338e-01));
        colors.push_back(Pixel(7.75795522e-01, 2.53657797e-01, 4.91170517e-01));
        colors.push_back(Pixel(7.79603614e-01, 2.58078397e-01, 4.87539124e-01));
        colors.push_back(Pixel(7.83382636e-01, 2.62499662e-01, 4.83917732e-01));
        colors.push_back(Pixel(7.87132978e-01, 2.66921859e-01, 4.80306702e-01));
        colors.push_back(Pixel(7.90855015e-01, 2.71345267e-01, 4.76706319e-01));
        colors.push_back(Pixel(7.94549101e-01, 2.75770179e-01, 4.73116798e-01));
        colors.push_back(Pixel(7.98215577e-01, 2.80196901e-01, 4.69538286e-01));
        colors.push_back(Pixel(8.01854758e-01, 2.84625750e-01, 4.65970871e-01));
        colors.push_back(Pixel(8.05466945e-01, 2.89057057e-01, 4.62414580e-01));
        colors.push_back(Pixel(8.09052419e-01, 2.93491117e-01, 4.58869577e-01));
        colors.push_back(Pixel(8.12611506e-01, 2.97927865e-01, 4.55337565e-01));
        colors.push_back(Pixel(8.16144382e-01, 3.02368130e-01, 4.51816385e-01));
        colors.push_back(Pixel(8.19651255e-01, 3.06812282e-01, 4.48305861e-01));
        colors.push_back(Pixel(8.23132309e-01, 3.11260703e-01, 4.44805781e-01));
        colors.push_back(Pixel(8.26587706e-01, 3.15713782e-01, 4.41315901e-01));
        colors.push_back(Pixel(8.30017584e-01, 3.20171913e-01, 4.37835947e-01));
        colors.push_back(Pixel(8.33422053e-01, 3.24635499e-01, 4.34365616e-01));
        colors.push_back(Pixel(8.36801237e-01, 3.29104836e-01, 4.30905052e-01));
        colors.push_back(Pixel(8.40155276e-01, 3.33580106e-01, 4.27454836e-01));
        colors.push_back(Pixel(8.43484103e-01, 3.38062109e-01, 4.24013059e-01));
        colors.push_back(Pixel(8.46787726e-01, 3.42551272e-01, 4.20579333e-01));
        colors.push_back(Pixel(8.50066132e-01, 3.47048028e-01, 4.17153264e-01));
        colors.push_back(Pixel(8.53319279e-01, 3.51552815e-01, 4.13734445e-01));
        colors.push_back(Pixel(8.56547103e-01, 3.56066072e-01, 4.10322469e-01));
        colors.push_back(Pixel(8.59749520e-01, 3.60588229e-01, 4.06916975e-01));
        colors.push_back(Pixel(8.62926559e-01, 3.65119408e-01, 4.03518809e-01));
        colors.push_back(Pixel(8.66077920e-01, 3.69660446e-01, 4.00126027e-01));
        colors.push_back(Pixel(8.69203436e-01, 3.74211795e-01, 3.96738211e-01));
        colors.push_back(Pixel(8.72302917e-01, 3.78773910e-01, 3.93354947e-01));
        colors.push_back(Pixel(8.75376149e-01, 3.83347243e-01, 3.89975832e-01));
        colors.push_back(Pixel(8.78422895e-01, 3.87932249e-01, 3.86600468e-01));
        colors.push_back(Pixel(8.81442916e-01, 3.92529339e-01, 3.83228622e-01));
        colors.push_back(Pixel(8.84435982e-01, 3.97138877e-01, 3.79860246e-01));
        colors.push_back(Pixel(8.87401682e-01, 4.01761511e-01, 3.76494232e-01));
        colors.push_back(Pixel(8.90339687e-01, 4.06397694e-01, 3.73130228e-01));
        colors.push_back(Pixel(8.93249647e-01, 4.11047871e-01, 3.69767893e-01));
        colors.push_back(Pixel(8.96131191e-01, 4.15712489e-01, 3.66406907e-01));
        colors.push_back(Pixel(8.98983931e-01, 4.20391986e-01, 3.63046965e-01));
        colors.push_back(Pixel(9.01807455e-01, 4.25086807e-01, 3.59687758e-01));
        colors.push_back(Pixel(9.04601295e-01, 4.29797442e-01, 3.56328796e-01));
        colors.push_back(Pixel(9.07364995e-01, 4.34524335e-01, 3.52969777e-01));
        colors.push_back(Pixel(9.10098088e-01, 4.39267908e-01, 3.49610469e-01));
        colors.push_back(Pixel(9.12800095e-01, 4.44028574e-01, 3.46250656e-01));
        colors.push_back(Pixel(9.15470518e-01, 4.48806744e-01, 3.42890148e-01));
        colors.push_back(Pixel(9.18108848e-01, 4.53602818e-01, 3.39528771e-01));
        colors.push_back(Pixel(9.20714383e-01, 4.58417420e-01, 3.36165582e-01));
        colors.push_back(Pixel(9.23286660e-01, 4.63250828e-01, 3.32800827e-01));
        colors.push_back(Pixel(9.25825146e-01, 4.68103387e-01, 3.29434512e-01));
        colors.push_back(Pixel(9.28329275e-01, 4.72975465e-01, 3.26066550e-01));
        colors.push_back(Pixel(9.30798469e-01, 4.77867420e-01, 3.22696876e-01));
        colors.push_back(Pixel(9.33232140e-01, 4.82779603e-01, 3.19325444e-01));
        colors.push_back(Pixel(9.35629684e-01, 4.87712357e-01, 3.15952211e-01));
        colors.push_back(Pixel(9.37990034e-01, 4.92666544e-01, 3.12575440e-01));
        colors.push_back(Pixel(9.40312939e-01, 4.97642038e-01, 3.09196628e-01));
        colors.push_back(Pixel(9.42597771e-01, 5.02639147e-01, 3.05815824e-01));
        colors.push_back(Pixel(9.44843893e-01, 5.07658169e-01, 3.02433101e-01));
        colors.push_back(Pixel(9.47050662e-01, 5.12699390e-01, 2.99048555e-01));
        colors.push_back(Pixel(9.49217427e-01, 5.17763087e-01, 2.95662308e-01));
        colors.push_back(Pixel(9.51343530e-01, 5.22849522e-01, 2.92274506e-01));
        colors.push_back(Pixel(9.53427725e-01, 5.27959550e-01, 2.88883445e-01));
        colors.push_back(Pixel(9.55469640e-01, 5.33093083e-01, 2.85490391e-01));
        colors.push_back(Pixel(9.57468770e-01, 5.38250172e-01, 2.82096149e-01));
        colors.push_back(Pixel(9.59424430e-01, 5.43431038e-01, 2.78700990e-01));
        colors.push_back(Pixel(9.61335930e-01, 5.48635890e-01, 2.75305214e-01));
        colors.push_back(Pixel(9.63202573e-01, 5.53864931e-01, 2.71909159e-01));
        colors.push_back(Pixel(9.65023656e-01, 5.59118349e-01, 2.68513200e-01));
        colors.push_back(Pixel(9.66798470e-01, 5.64396327e-01, 2.65117752e-01));
        colors.push_back(Pixel(9.68525639e-01, 5.69699633e-01, 2.61721488e-01));
        colors.push_back(Pixel(9.70204593e-01, 5.75028270e-01, 2.58325424e-01));
        colors.push_back(Pixel(9.71835007e-01, 5.80382015e-01, 2.54931256e-01));
        colors.push_back(Pixel(9.73416145e-01, 5.85761012e-01, 2.51539615e-01));
        colors.push_back(Pixel(9.74947262e-01, 5.91165394e-01, 2.48151200e-01));
        colors.push_back(Pixel(9.76427606e-01, 5.96595287e-01, 2.44766775e-01));
        colors.push_back(Pixel(9.77856416e-01, 6.02050811e-01, 2.41387186e-01));
        colors.push_back(Pixel(9.79232922e-01, 6.07532077e-01, 2.38013359e-01));
        colors.push_back(Pixel(9.80556344e-01, 6.13039190e-01, 2.34646316e-01));
        colors.push_back(Pixel(9.81825890e-01, 6.18572250e-01, 2.31287178e-01));
        colors.push_back(Pixel(9.83040742e-01, 6.24131362e-01, 2.27937141e-01));
        colors.push_back(Pixel(9.84198924e-01, 6.29717516e-01, 2.24595006e-01));
        colors.push_back(Pixel(9.85300760e-01, 6.35329876e-01, 2.21264889e-01));
        colors.push_back(Pixel(9.86345421e-01, 6.40968508e-01, 2.17948456e-01));
        colors.push_back(Pixel(9.87332067e-01, 6.46633475e-01, 2.14647532e-01));
        colors.push_back(Pixel(9.88259846e-01, 6.52324832e-01, 2.11364122e-01));
        colors.push_back(Pixel(9.89127893e-01, 6.58042630e-01, 2.08100426e-01));
        colors.push_back(Pixel(9.89935328e-01, 6.63786914e-01, 2.04858855e-01));
        colors.push_back(Pixel(9.90681261e-01, 6.69557720e-01, 2.01642049e-01));
        colors.push_back(Pixel(9.91364787e-01, 6.75355082e-01, 1.98452900e-01));
        colors.push_back(Pixel(9.91984990e-01, 6.81179025e-01, 1.95294567e-01));
        colors.push_back(Pixel(9.92540939e-01, 6.87029567e-01, 1.92170500e-01));
        colors.push_back(Pixel(9.93031693e-01, 6.92906719e-01, 1.89084459e-01));
        colors.push_back(Pixel(9.93456302e-01, 6.98810484e-01, 1.86040537e-01));
        colors.push_back(Pixel(9.93813802e-01, 7.04740854e-01, 1.83043180e-01));
        colors.push_back(Pixel(9.94103226e-01, 7.10697814e-01, 1.80097207e-01));
        colors.push_back(Pixel(9.94323596e-01, 7.16681336e-01, 1.77207826e-01));
        colors.push_back(Pixel(9.94473934e-01, 7.22691379e-01, 1.74380656e-01));
        colors.push_back(Pixel(9.94553260e-01, 7.28727890e-01, 1.71621733e-01));
        colors.push_back(Pixel(9.94560594e-01, 7.34790799e-01, 1.68937522e-01));
        colors.push_back(Pixel(9.94494964e-01, 7.40880020e-01, 1.66334918e-01));
        colors.push_back(Pixel(9.94355411e-01, 7.46995448e-01, 1.63821243e-01));
        colors.push_back(Pixel(9.94140989e-01, 7.53136955e-01, 1.61404226e-01));
        colors.push_back(Pixel(9.93850778e-01, 7.59304390e-01, 1.59091984e-01));
        colors.push_back(Pixel(9.93482190e-01, 7.65498551e-01, 1.56890625e-01));
        colors.push_back(Pixel(9.93033251e-01, 7.71719833e-01, 1.54807583e-01));
        colors.push_back(Pixel(9.92505214e-01, 7.77966775e-01, 1.52854862e-01));
        colors.push_back(Pixel(9.91897270e-01, 7.84239120e-01, 1.51041581e-01));
        colors.push_back(Pixel(9.91208680e-01, 7.90536569e-01, 1.49376885e-01));
        colors.push_back(Pixel(9.90438793e-01, 7.96858775e-01, 1.47869810e-01));
        colors.push_back(Pixel(9.89587065e-01, 8.03205337e-01, 1.46529128e-01));
        colors.push_back(Pixel(9.88647741e-01, 8.09578605e-01, 1.45357284e-01));
        colors.push_back(Pixel(9.87620557e-01, 8.15977942e-01, 1.44362644e-01));
        colors.push_back(Pixel(9.86509366e-01, 8.22400620e-01, 1.43556679e-01));
        colors.push_back(Pixel(9.85314198e-01, 8.28845980e-01, 1.42945116e-01));
        colors.push_back(Pixel(9.84031139e-01, 8.35315360e-01, 1.42528388e-01));
        colors.push_back(Pixel(9.82652820e-01, 8.41811730e-01, 1.42302653e-01));
        colors.push_back(Pixel(9.81190389e-01, 8.48328902e-01, 1.42278607e-01));
        colors.push_back(Pixel(9.79643637e-01, 8.54866468e-01, 1.42453425e-01));
        colors.push_back(Pixel(9.77994918e-01, 8.61432314e-01, 1.42808191e-01));
        colors.push_back(Pixel(9.76264977e-01, 8.68015998e-01, 1.43350944e-01));
        colors.push_back(Pixel(9.74443038e-01, 8.74622194e-01, 1.44061156e-01));
        colors.push_back(Pixel(9.72530009e-01, 8.81250063e-01, 1.44922913e-01));
        colors.push_back(Pixel(9.70532932e-01, 8.87896125e-01, 1.45918663e-01));
        colors.push_back(Pixel(9.68443477e-01, 8.94563989e-01, 1.47014438e-01));
        colors.push_back(Pixel(9.66271225e-01, 9.01249365e-01, 1.48179639e-01));
        colors.push_back(Pixel(9.64021057e-01, 9.07950379e-01, 1.49370428e-01));
        colors.push_back(Pixel(9.61681481e-01, 9.14672479e-01, 1.50520343e-01));
        colors.push_back(Pixel(9.59275646e-01, 9.21406537e-01, 1.51566019e-01));
        colors.push_back(Pixel(9.56808068e-01, 9.28152065e-01, 1.52409489e-01));
        colors.push_back(Pixel(9.54286813e-01, 9.34907730e-01, 1.52921158e-01));
        colors.push_back(Pixel(9.51726083e-01, 9.41670605e-01, 1.52925363e-01));
        colors.push_back(Pixel(9.49150533e-01, 9.48434900e-01, 1.52177604e-01));
        colors.push_back(Pixel(9.46602270e-01, 9.55189860e-01, 1.50327944e-01));
        colors.push_back(Pixel(9.44151742e-01, 9.61916487e-01, 1.46860789e-01));
        colors.push_back(Pixel(9.41896120e-01, 9.68589814e-01, 1.40955606e-01));
        colors.push_back(Pixel(9.40015097e-01, 9.75158357e-01, 1.31325517e-01));
    }

    static void color_map_viridis(std::vector<Pixel> &colors)
    {
        colors.push_back(Pixel(0.267004, 0.004874, 0.329415));
        colors.push_back(Pixel(0.268510, 0.009605, 0.335427));
        colors.push_back(Pixel(0.269944, 0.014625, 0.341379));
        colors.push_back(Pixel(0.271305, 0.019942, 0.347269));
        colors.push_back(Pixel(0.272594, 0.025563, 0.353093));
        colors.push_back(Pixel(0.273809, 0.031497, 0.358853));
        colors.push_back(Pixel(0.274952, 0.037752, 0.364543));
        colors.push_back(Pixel(0.276022, 0.044167, 0.370164));
        colors.push_back(Pixel(0.277018, 0.050344, 0.375715));
        colors.push_back(Pixel(0.277941, 0.056324, 0.381191));
        colors.push_back(Pixel(0.278791, 0.062145, 0.386592));
        colors.push_back(Pixel(0.279566, 0.067836, 0.391917));
        colors.push_back(Pixel(0.280267, 0.073417, 0.397163));
        colors.push_back(Pixel(0.280894, 0.078907, 0.402329));
        colors.push_back(Pixel(0.281446, 0.084320, 0.407414));
        colors.push_back(Pixel(0.281924, 0.089666, 0.412415));
        colors.push_back(Pixel(0.282327, 0.094955, 0.417331));
        colors.push_back(Pixel(0.282656, 0.100196, 0.422160));
        colors.push_back(Pixel(0.282910, 0.105393, 0.426902));
        colors.push_back(Pixel(0.283091, 0.110553, 0.431554));
        colors.push_back(Pixel(0.283197, 0.115680, 0.436115));
        colors.push_back(Pixel(0.283229, 0.120777, 0.440584));
        colors.push_back(Pixel(0.283187, 0.125848, 0.444960));
        colors.push_back(Pixel(0.283072, 0.130895, 0.449241));
        colors.push_back(Pixel(0.282884, 0.135920, 0.453427));
        colors.push_back(Pixel(0.282623, 0.140926, 0.457517));
        colors.push_back(Pixel(0.282290, 0.145912, 0.461510));
        colors.push_back(Pixel(0.281887, 0.150881, 0.465405));
        colors.push_back(Pixel(0.281412, 0.155834, 0.469201));
        colors.push_back(Pixel(0.280868, 0.160771, 0.472899));
        colors.push_back(Pixel(0.280255, 0.165693, 0.476498));
        colors.push_back(Pixel(0.279574, 0.170599, 0.479997));
        colors.push_back(Pixel(0.278826, 0.175490, 0.483397));
        colors.push_back(Pixel(0.278012, 0.180367, 0.486697));
        colors.push_back(Pixel(0.277134, 0.185228, 0.489898));
        colors.push_back(Pixel(0.276194, 0.190074, 0.493001));
        colors.push_back(Pixel(0.275191, 0.194905, 0.496005));
        colors.push_back(Pixel(0.274128, 0.199721, 0.498911));
        colors.push_back(Pixel(0.273006, 0.204520, 0.501721));
        colors.push_back(Pixel(0.271828, 0.209303, 0.504434));
        colors.push_back(Pixel(0.270595, 0.214069, 0.507052));
        colors.push_back(Pixel(0.269308, 0.218818, 0.509577));
        colors.push_back(Pixel(0.267968, 0.223549, 0.512008));
        colors.push_back(Pixel(0.266580, 0.228262, 0.514349));
        colors.push_back(Pixel(0.265145, 0.232956, 0.516599));
        colors.push_back(Pixel(0.263663, 0.237631, 0.518762));
        colors.push_back(Pixel(0.262138, 0.242286, 0.520837));
        colors.push_back(Pixel(0.260571, 0.246922, 0.522828));
        colors.push_back(Pixel(0.258965, 0.251537, 0.524736));
        colors.push_back(Pixel(0.257322, 0.256130, 0.526563));
        colors.push_back(Pixel(0.255645, 0.260703, 0.528312));
        colors.push_back(Pixel(0.253935, 0.265254, 0.529983));
        colors.push_back(Pixel(0.252194, 0.269783, 0.531579));
        colors.push_back(Pixel(0.250425, 0.274290, 0.533103));
        colors.push_back(Pixel(0.248629, 0.278775, 0.534556));
        colors.push_back(Pixel(0.246811, 0.283237, 0.535941));
        colors.push_back(Pixel(0.244972, 0.287675, 0.537260));
        colors.push_back(Pixel(0.243113, 0.292092, 0.538516));
        colors.push_back(Pixel(0.241237, 0.296485, 0.539709));
        colors.push_back(Pixel(0.239346, 0.300855, 0.540844));
        colors.push_back(Pixel(0.237441, 0.305202, 0.541921));
        colors.push_back(Pixel(0.235526, 0.309527, 0.542944));
        colors.push_back(Pixel(0.233603, 0.313828, 0.543914));
        colors.push_back(Pixel(0.231674, 0.318106, 0.544834));
        colors.push_back(Pixel(0.229739, 0.322361, 0.545706));
        colors.push_back(Pixel(0.227802, 0.326594, 0.546532));
        colors.push_back(Pixel(0.225863, 0.330805, 0.547314));
        colors.push_back(Pixel(0.223925, 0.334994, 0.548053));
        colors.push_back(Pixel(0.221989, 0.339161, 0.548752));
        colors.push_back(Pixel(0.220057, 0.343307, 0.549413));
        colors.push_back(Pixel(0.218130, 0.347432, 0.550038));
        colors.push_back(Pixel(0.216210, 0.351535, 0.550627));
        colors.push_back(Pixel(0.214298, 0.355619, 0.551184));
        colors.push_back(Pixel(0.212395, 0.359683, 0.551710));
        colors.push_back(Pixel(0.210503, 0.363727, 0.552206));
        colors.push_back(Pixel(0.208623, 0.367752, 0.552675));
        colors.push_back(Pixel(0.206756, 0.371758, 0.553117));
        colors.push_back(Pixel(0.204903, 0.375746, 0.553533));
        colors.push_back(Pixel(0.203063, 0.379716, 0.553925));
        colors.push_back(Pixel(0.201239, 0.383670, 0.554294));
        colors.push_back(Pixel(0.199430, 0.387607, 0.554642));
        colors.push_back(Pixel(0.197636, 0.391528, 0.554969));
        colors.push_back(Pixel(0.195860, 0.395433, 0.555276));
        colors.push_back(Pixel(0.194100, 0.399323, 0.555565));
        colors.push_back(Pixel(0.192357, 0.403199, 0.555836));
        colors.push_back(Pixel(0.190631, 0.407061, 0.556089));
        colors.push_back(Pixel(0.188923, 0.410910, 0.556326));
        colors.push_back(Pixel(0.187231, 0.414746, 0.556547));
        colors.push_back(Pixel(0.185556, 0.418570, 0.556753));
        colors.push_back(Pixel(0.183898, 0.422383, 0.556944));
        colors.push_back(Pixel(0.182256, 0.426184, 0.557120));
        colors.push_back(Pixel(0.180629, 0.429975, 0.557282));
        colors.push_back(Pixel(0.179019, 0.433756, 0.557430));
        colors.push_back(Pixel(0.177423, 0.437527, 0.557565));
        colors.push_back(Pixel(0.175841, 0.441290, 0.557685));
        colors.push_back(Pixel(0.174274, 0.445044, 0.557792));
        colors.push_back(Pixel(0.172719, 0.448791, 0.557885));
        colors.push_back(Pixel(0.171176, 0.452530, 0.557965));
        colors.push_back(Pixel(0.169646, 0.456262, 0.558030));
        colors.push_back(Pixel(0.168126, 0.459988, 0.558082));
        colors.push_back(Pixel(0.166617, 0.463708, 0.558119));
        colors.push_back(Pixel(0.165117, 0.467423, 0.558141));
        colors.push_back(Pixel(0.163625, 0.471133, 0.558148));
        colors.push_back(Pixel(0.162142, 0.474838, 0.558140));
        colors.push_back(Pixel(0.160665, 0.478540, 0.558115));
        colors.push_back(Pixel(0.159194, 0.482237, 0.558073));
        colors.push_back(Pixel(0.157729, 0.485932, 0.558013));
        colors.push_back(Pixel(0.156270, 0.489624, 0.557936));
        colors.push_back(Pixel(0.154815, 0.493313, 0.557840));
        colors.push_back(Pixel(0.153364, 0.497000, 0.557724));
        colors.push_back(Pixel(0.151918, 0.500685, 0.557587));
        colors.push_back(Pixel(0.150476, 0.504369, 0.557430));
        colors.push_back(Pixel(0.149039, 0.508051, 0.557250));
        colors.push_back(Pixel(0.147607, 0.511733, 0.557049));
        colors.push_back(Pixel(0.146180, 0.515413, 0.556823));
        colors.push_back(Pixel(0.144759, 0.519093, 0.556572));
        colors.push_back(Pixel(0.143343, 0.522773, 0.556295));
        colors.push_back(Pixel(0.141935, 0.526453, 0.555991));
        colors.push_back(Pixel(0.140536, 0.530132, 0.555659));
        colors.push_back(Pixel(0.139147, 0.533812, 0.555298));
        colors.push_back(Pixel(0.137770, 0.537492, 0.554906));
        colors.push_back(Pixel(0.136408, 0.541173, 0.554483));
        colors.push_back(Pixel(0.135066, 0.544853, 0.554029));
        colors.push_back(Pixel(0.133743, 0.548535, 0.553541));
        colors.push_back(Pixel(0.132444, 0.552216, 0.553018));
        colors.push_back(Pixel(0.131172, 0.555899, 0.552459));
        colors.push_back(Pixel(0.129933, 0.559582, 0.551864));
        colors.push_back(Pixel(0.128729, 0.563265, 0.551229));
        colors.push_back(Pixel(0.127568, 0.566949, 0.550556));
        colors.push_back(Pixel(0.126453, 0.570633, 0.549841));
        colors.push_back(Pixel(0.125394, 0.574318, 0.549086));
        colors.push_back(Pixel(0.124395, 0.578002, 0.548287));
        colors.push_back(Pixel(0.123463, 0.581687, 0.547445));
        colors.push_back(Pixel(0.122606, 0.585371, 0.546557));
        colors.push_back(Pixel(0.121831, 0.589055, 0.545623));
        colors.push_back(Pixel(0.121148, 0.592739, 0.544641));
        colors.push_back(Pixel(0.120565, 0.596422, 0.543611));
        colors.push_back(Pixel(0.120092, 0.600104, 0.542530));
        colors.push_back(Pixel(0.119738, 0.603785, 0.541400));
        colors.push_back(Pixel(0.119512, 0.607464, 0.540218));
        colors.push_back(Pixel(0.119423, 0.611141, 0.538982));
        colors.push_back(Pixel(0.119483, 0.614817, 0.537692));
        colors.push_back(Pixel(0.119699, 0.618490, 0.536347));
        colors.push_back(Pixel(0.120081, 0.622161, 0.534946));
        colors.push_back(Pixel(0.120638, 0.625828, 0.533488));
        colors.push_back(Pixel(0.121380, 0.629492, 0.531973));
        colors.push_back(Pixel(0.122312, 0.633153, 0.530398));
        colors.push_back(Pixel(0.123444, 0.636809, 0.528763));
        colors.push_back(Pixel(0.124780, 0.640461, 0.527068));
        colors.push_back(Pixel(0.126326, 0.644107, 0.525311));
        colors.push_back(Pixel(0.128087, 0.647749, 0.523491));
        colors.push_back(Pixel(0.130067, 0.651384, 0.521608));
        colors.push_back(Pixel(0.132268, 0.655014, 0.519661));
        colors.push_back(Pixel(0.134692, 0.658636, 0.517649));
        colors.push_back(Pixel(0.137339, 0.662252, 0.515571));
        colors.push_back(Pixel(0.140210, 0.665859, 0.513427));
        colors.push_back(Pixel(0.143303, 0.669459, 0.511215));
        colors.push_back(Pixel(0.146616, 0.673050, 0.508936));
        colors.push_back(Pixel(0.150148, 0.676631, 0.506589));
        colors.push_back(Pixel(0.153894, 0.680203, 0.504172));
        colors.push_back(Pixel(0.157851, 0.683765, 0.501686));
        colors.push_back(Pixel(0.162016, 0.687316, 0.499129));
        colors.push_back(Pixel(0.166383, 0.690856, 0.496502));
        colors.push_back(Pixel(0.170948, 0.694384, 0.493803));
        colors.push_back(Pixel(0.175707, 0.697900, 0.491033));
        colors.push_back(Pixel(0.180653, 0.701402, 0.488189));
        colors.push_back(Pixel(0.185783, 0.704891, 0.485273));
        colors.push_back(Pixel(0.191090, 0.708366, 0.482284));
        colors.push_back(Pixel(0.196571, 0.711827, 0.479221));
        colors.push_back(Pixel(0.202219, 0.715272, 0.476084));
        colors.push_back(Pixel(0.208030, 0.718701, 0.472873));
        colors.push_back(Pixel(0.214000, 0.722114, 0.469588));
        colors.push_back(Pixel(0.220124, 0.725509, 0.466226));
        colors.push_back(Pixel(0.226397, 0.728888, 0.462789));
        colors.push_back(Pixel(0.232815, 0.732247, 0.459277));
        colors.push_back(Pixel(0.239374, 0.735588, 0.455688));
        colors.push_back(Pixel(0.246070, 0.738910, 0.452024));
        colors.push_back(Pixel(0.252899, 0.742211, 0.448284));
        colors.push_back(Pixel(0.259857, 0.745492, 0.444467));
        colors.push_back(Pixel(0.266941, 0.748751, 0.440573));
        colors.push_back(Pixel(0.274149, 0.751988, 0.436601));
        colors.push_back(Pixel(0.281477, 0.755203, 0.432552));
        colors.push_back(Pixel(0.288921, 0.758394, 0.428426));
        colors.push_back(Pixel(0.296479, 0.761561, 0.424223));
        colors.push_back(Pixel(0.304148, 0.764704, 0.419943));
        colors.push_back(Pixel(0.311925, 0.767822, 0.415586));
        colors.push_back(Pixel(0.319809, 0.770914, 0.411152));
        colors.push_back(Pixel(0.327796, 0.773980, 0.406640));
        colors.push_back(Pixel(0.335885, 0.777018, 0.402049));
        colors.push_back(Pixel(0.344074, 0.780029, 0.397381));
        colors.push_back(Pixel(0.352360, 0.783011, 0.392636));
        colors.push_back(Pixel(0.360741, 0.785964, 0.387814));
        colors.push_back(Pixel(0.369214, 0.788888, 0.382914));
        colors.push_back(Pixel(0.377779, 0.791781, 0.377939));
        colors.push_back(Pixel(0.386433, 0.794644, 0.372886));
        colors.push_back(Pixel(0.395174, 0.797475, 0.367757));
        colors.push_back(Pixel(0.404001, 0.800275, 0.362552));
        colors.push_back(Pixel(0.412913, 0.803041, 0.357269));
        colors.push_back(Pixel(0.421908, 0.805774, 0.351910));
        colors.push_back(Pixel(0.430983, 0.808473, 0.346476));
        colors.push_back(Pixel(0.440137, 0.811138, 0.340967));
        colors.push_back(Pixel(0.449368, 0.813768, 0.335384));
        colors.push_back(Pixel(0.458674, 0.816363, 0.329727));
        colors.push_back(Pixel(0.468053, 0.818921, 0.323998));
        colors.push_back(Pixel(0.477504, 0.821444, 0.318195));
        colors.push_back(Pixel(0.487026, 0.823929, 0.312321));
        colors.push_back(Pixel(0.496615, 0.826376, 0.306377));
        colors.push_back(Pixel(0.506271, 0.828786, 0.300362));
        colors.push_back(Pixel(0.515992, 0.831158, 0.294279));
        colors.push_back(Pixel(0.525776, 0.833491, 0.288127));
        colors.push_back(Pixel(0.535621, 0.835785, 0.281908));
        colors.push_back(Pixel(0.545524, 0.838039, 0.275626));
        colors.push_back(Pixel(0.555484, 0.840254, 0.269281));
        colors.push_back(Pixel(0.565498, 0.842430, 0.262877));
        colors.push_back(Pixel(0.575563, 0.844566, 0.256415));
        colors.push_back(Pixel(0.585678, 0.846661, 0.249897));
        colors.push_back(Pixel(0.595839, 0.848717, 0.243329));
        colors.push_back(Pixel(0.606045, 0.850733, 0.236712));
        colors.push_back(Pixel(0.616293, 0.852709, 0.230052));
        colors.push_back(Pixel(0.626579, 0.854645, 0.223353));
        colors.push_back(Pixel(0.636902, 0.856542, 0.216620));
        colors.push_back(Pixel(0.647257, 0.858400, 0.209861));
        colors.push_back(Pixel(0.657642, 0.860219, 0.203082));
        colors.push_back(Pixel(0.668054, 0.861999, 0.196293));
        colors.push_back(Pixel(0.678489, 0.863742, 0.189503));
        colors.push_back(Pixel(0.688944, 0.865448, 0.182725));
        colors.push_back(Pixel(0.699415, 0.867117, 0.175971));
        colors.push_back(Pixel(0.709898, 0.868751, 0.169257));
        colors.push_back(Pixel(0.720391, 0.870350, 0.162603));
        colors.push_back(Pixel(0.730889, 0.871916, 0.156029));
        colors.push_back(Pixel(0.741388, 0.873449, 0.149561));
        colors.push_back(Pixel(0.751884, 0.874951, 0.143228));
        colors.push_back(Pixel(0.762373, 0.876424, 0.137064));
        colors.push_back(Pixel(0.772852, 0.877868, 0.131109));
        colors.push_back(Pixel(0.783315, 0.879285, 0.125405));
        colors.push_back(Pixel(0.793760, 0.880678, 0.120005));
        colors.push_back(Pixel(0.804182, 0.882046, 0.114965));
        colors.push_back(Pixel(0.814576, 0.883393, 0.110347));
        colors.push_back(Pixel(0.824940, 0.884720, 0.106217));
        colors.push_back(Pixel(0.835270, 0.886029, 0.102646));
        colors.push_back(Pixel(0.845561, 0.887322, 0.099702));
        colors.push_back(Pixel(0.855810, 0.888601, 0.097452));
        colors.push_back(Pixel(0.866013, 0.889868, 0.095953));
        colors.push_back(Pixel(0.876168, 0.891125, 0.095250));
        colors.push_back(Pixel(0.886271, 0.892374, 0.095374));
        colors.push_back(Pixel(0.896320, 0.893616, 0.096335));
        colors.push_back(Pixel(0.906311, 0.894855, 0.098125));
        colors.push_back(Pixel(0.916242, 0.896091, 0.100717));
        colors.push_back(Pixel(0.926106, 0.897330, 0.104071));
        colors.push_back(Pixel(0.935904, 0.898570, 0.108131));
        colors.push_back(Pixel(0.945636, 0.899815, 0.112838));
        colors.push_back(Pixel(0.955300, 0.901065, 0.118128));
        colors.push_back(Pixel(0.964894, 0.902323, 0.123941));
        colors.push_back(Pixel(0.974417, 0.903590, 0.130215));
        colors.push_back(Pixel(0.983868, 0.904867, 0.136897));
        colors.push_back(Pixel(0.993248, 0.906157, 0.143936));
    }

    static void color_map_seaborn_dark(std::vector<Pixel> &colors)
    {
        // colors.push_back(Pixel(0.008807212146830987, 0.05296224908259193, 0.20091135609359057));
        // colors.push_back(Pixel(0.007721969116745276, 0.041096511969554404, 0.1482790689603804));
        // colors.push_back(Pixel(0.00672975220031578, 0.031150254991731324, 0.10574902166115163));
        // colors.push_back(Pixel(0.0058263930141070775, 0.02295412342092056, 0.07224472181168486));
        // colors.push_back(Pixel(0.004984973104844826, 0.016167060097766292, 0.046049870578402444));
        // colors.push_back(Pixel(0.004249120392189269, 0.011001911771735717, 0.027552708033159876));
        // colors.push_back(Pixel(0.003589498138839791, 0.007073863103808235, 0.01482027792220297));
        // colors.push_back(Pixel(0.003001937961360972, 0.004213559365781713, 0.00677608786131255));
        // colors.push_back(Pixel(0.008778258353123326, 0.0029403679272225194, 0.0026838273948644933));
        // colors.push_back(Pixel(0.019757083550865966, 0.003651616699711317, 0.0029872306486543165));
        // colors.push_back(Pixel(0.03739064043817814, 0.004469201356394607, 0.0033126794514833813));
        // colors.push_back(Pixel(0.06325566428161873, 0.005400529907145417, 0.0036609469669089266));
        // colors.push_back(Pixel(0.1001379695283727, 0.006485746983073283, 0.004044064270730524));
        // colors.push_back(Pixel(0.14755344954362587, 0.007670665450245777, 0.004441014178987363));
        // colors.push_back(Pixel(0.20797679573069658, 0.008991768872644119, 0.004863124941788477));
        // colors.push_back(Pixel(0.28298474335614393, 0.010456465260141325, 0.005311169722691106));

        colors.push_back(Pixel(0.16390215524291413, 0.2929414203686874, 0.5812265028729282));
        colors.push_back(Pixel(0.13308222439460596, 0.23276043797232718, 0.45352691795408684));
        colors.push_back(Pixel(0.10572690829299, 0.18003886433355495, 0.3428848991307251));
        colors.push_back(Pixel(0.08176437964727781, 0.13460423689330822, 0.24887132778934706));
        colors.push_back(Pixel(0.060560323308830905, 0.09524766810116077, 0.16896438784340384));
        colors.push_back(Pixel(0.04323277612350815, 0.06399024820809661, 0.10715460588250635));
        colors.push_back(Pixel(0.02903246837612451, 0.03936360617384035, 0.06029780117406371));
        colors.push_back(Pixel(0.017847736439541597, 0.02107934583592481, 0.02762540092993695));
        colors.push_back(Pixel(0.03152523544461394, 0.017895520847167518, 0.01730115926202401));
        colors.push_back(Pixel(0.06888964274332016, 0.030162278311120966, 0.028454635655749322));
        colors.push_back(Pixel(0.12249959751378944, 0.045980070951883896, 0.04268390754418061));
        colors.push_back(Pixel(0.19323635565197167, 0.06548835580455277, 0.06010502304915221));
        colors.push_back(Pixel(0.2847001490877622, 0.08954993226890397, 0.08147664912951863));
        colors.push_back(Pixel(0.3923242116582001, 0.11690483748520515, 0.10567433338626726));
        colors.push_back(Pixel(0.5189956311050412, 0.14827790857149734, 0.13333879359942594));
        colors.push_back(Pixel(0.6652062121247165, 0.18375706897102786, 0.16454420695780053));
    }

}
