
// /*
//     pbrt source code is Copyright(c) 1998-2016
//                         Matt Pharr, Greg Humphreys, and Wenzel Jakob.

//     This file is part of pbrt.

//     Redistribution and use in source and binary forms, with or without
//     modification, are permitted provided that the following conditions are
//     met:

//     - Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.

//     - Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.

//     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
//     IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
//     TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
//     PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
//     HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
//     SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//     LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
//     DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
//     THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
//     OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

//  */

// // media/homogeneous.cpp*
// #include "media/homogeneous.h"
// #include "sampler.h"
// #include "interaction.h"
// #include "paramset.h"
// #include "stats.h"

// namespace pbrt {

// // HomogeneousMedium Method Definitions
// #if RENDER_MUTABLE
// Spectrum HomogeneousMedium::Tr(const Ray &ray, Sampler &sampler) {
//     ProfilePhase _(Prof::MediumTr);

//     return Exp(-sigma_t * std::min(ray.tMax * ray.d.Length(), MaxFloat));
// }

// Spectrum HomogeneousMedium::Sample(const Ray &ray,
//                                    Sampler& ff_sampler,
//                                    Sampler& trans_sampler,
//                                    MemoryArena &arena,
//                                    MediumInteraction *mi) {
//     ProfilePhase _(Prof::MediumSample);
//     // Sample a channel and distance along the ray
//     int channel = std::min((int)(ff_sampler.Get1D() * Spectrum::nSamples),
//                            Spectrum::nSamples - 1);
//     Float dist = -std::log(1 - ff_sampler.Get1D()) / sigma_t[channel];
//     Float t = std::min(dist / ray.d.Length(), ray.tMax);
//     bool sampledMedium = t < ray.tMax;
//     if (sampledMedium)
//         *mi = MediumInteraction(ray(t), -ray.d, ray.time, this,
//                                 ARENA_ALLOC(arena, HenyeyGreenstein)(g));

//     // Compute the transmittance and sampling density
//     Spectrum Tr = Exp(-sigma_t * std::min(t, MaxFloat) * ray.d.Length());

//     // Return weighting factor for scattering from homogeneous medium
//     Spectrum density = sampledMedium ? (sigma_t * Tr) : Tr;
//     Float pdf = 0;
//     for (int i = 0; i < Spectrum::nSamples; ++i) pdf += density[i];
//     pdf *= 1 / (Float)Spectrum::nSamples;
//     if (pdf == 0)
//     {
//         #if LOGGING
//             CHECK(Tr.IsBlack());
//         #endif
//         pdf = 1;
//     }
//     return sampledMedium ? (Tr * sigma_s / pdf) : (Tr / pdf);
// }
// #else
// Spectrum HomogeneousMedium::Tr(const Ray &ray, Sampler &sampler) const {
//     ProfilePhase _(Prof::MediumTr);

//     return Exp(-sigma_t * std::min(ray.tMax * ray.d.Length(), MaxFloat));
// }

// Spectrum HomogeneousMedium::Sample(const Ray &ray,
//                                    Sampler& ff_sampler,
//                                    Sampler& trans_sampler,
//                                    MemoryArena &arena,
//                                    MediumInteraction *mi) const {
//     ProfilePhase _(Prof::MediumSample);
//     // Sample a channel and distance along the ray
//     int channel = std::min((int)(ff_sampler.Get1D() * Spectrum::nSamples),
//                            Spectrum::nSamples - 1);
//     Float dist = -std::log(1 - ff_sampler.Get1D()) / sigma_t[channel];
//     Float t = std::min(dist / ray.d.Length(), ray.tMax);
//     bool sampledMedium = t < ray.tMax;
//     if (sampledMedium)
//         *mi = MediumInteraction(ray(t), -ray.d, ray.time, this,
//                                 ARENA_ALLOC(arena, HenyeyGreenstein)(g));

//     // Compute the transmittance and sampling density
//     Spectrum Tr = Exp(-sigma_t * std::min(t, MaxFloat) * ray.d.Length());

//     // Return weighting factor for scattering from homogeneous medium
//     Spectrum density = sampledMedium ? (sigma_t * Tr) : Tr;
//     Float pdf = 0;
//     for (int i = 0; i < Spectrum::nSamples; ++i) pdf += density[i];
//     pdf *= 1 / (Float)Spectrum::nSamples;
//     if (pdf == 0)
//     {
//         #if LOGGING
//             CHECK(Tr.IsBlack());
//         #endif
//         pdf = 1;
//     }
//     return sampledMedium ? (Tr * sigma_s / pdf) : (Tr / pdf);
// }
// #endif

// }  // namespace pbrt
